/* This SQL Script prepares a new database to be used by Winshuttle Workflow */

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFMANAGEDATTR_WFACTDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFMANAGEDATTR] DROP CONSTRAINT FK_WFMANAGEDATTR_WFACTDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[FK_WFSUBPROCREG_WFPROCESS]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFSUBPROCREG] DROP CONSTRAINT FK_WFSUBPROCREG_WFPROCESS
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFASSIGNMENT_WFASSIGNMENTSTATUS]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFASSIGNMENT] DROP CONSTRAINT FK_WFASSIGNMENT_WFASSIGNMENTSTATUS
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFACTDEF_WFPROCDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFACTDEF] DROP CONSTRAINT FK_WFACTDEF_WFPROCDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFATTRIBUTEDEF_WFPROCDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFATTRIBUTEDEF] DROP CONSTRAINT FK_WFATTRIBUTEDEF_WFPROCDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFPERFORMERDEF_WFPROCDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFPERFORMERDEF] DROP CONSTRAINT FK_WFPERFORMERDEF_WFPROCDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFPROCESS_WFPROCDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFPROCESS] DROP CONSTRAINT FK_WFPROCESS_WFPROCDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFTRANSDEF_WFPROCDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFTRANSDEF] DROP CONSTRAINT FK_WFTRANSDEF_WFPROCDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFACTORGROUP_WFPROCDEF]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFACTORGROUP] DROP CONSTRAINT FK_WFACTORGROUP_WFPROCDEF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFASSIGNMENT_WFPROCESS]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFASSIGNMENT] DROP CONSTRAINT FK_WFASSIGNMENT_WFPROCESS
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFATTRIBUTE_WFPROCESS]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFATTRIBUTE] DROP CONSTRAINT FK_WFATTRIBUTE_WFPROCESS
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFPERFORMER_WFPROCESS]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFPERFORMER] DROP CONSTRAINT FK_WFPERFORMER_WFPROCESS
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFPERFORMER_WFPROCESS2]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFPERFORMER] DROP CONSTRAINT FK_WFPERFORMER_WFPROCESS2
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WFPROCESS_WFPROCESSSTATUS]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WFPROCESS] DROP CONSTRAINT FK_WFPROCESS_WFPROCESSSTATUS
GO

if exists (select * from dbo.sysobjects where id = OBJECT_ID(N'[DF_WSSLN_CreatedOn]') AND type = 'D')
ALTER TABLE [dbo].[WSSLN] DROP CONSTRAINT [DF_WSSLN_CreatedOn]
GO

if exists (select * from dbo.sysobjects where id = OBJECT_ID(N'[DF_WSSLN_Visible]') AND type = 'D')
ALTER TABLE [dbo].[WSSLN] DROP CONSTRAINT [DF_WSSLN_Visible]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AssignmentView]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[AssignmentView]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AssignmentView2]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[AssignmentView2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ProcessView]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[ProcessView]
GO

CREATE TABLE [dbo].[WSFieldPackRef](
	[ID] [bigint] IDENTITY(1,1) NOT NULL,
	[SiteGUID] [nvarchar](100) NOT NULL,
	[FormName] [nvarchar](256) NOT NULL,
	[Version] [int] NOT NULL ,
	[FPId] [nvarchar](256) NOT NULL,
   CONSTRAINT [PK_WSFieldPackRef] PRIMARY KEY CLUSTERED 
   (
	[ID] ASC
   ) WITH (PAD_INDEX = OFF, 
           STATISTICS_NORECOMPUTE = OFF, 
           IGNORE_DUP_KEY = OFF, 
           ALLOW_ROW_LOCKS = ON, 
           ALLOW_PAGE_LOCKS = ON) 
     ON [PRIMARY],
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WSFieldPack](
	[ID] [bigint] IDENTITY(1,1) NOT NULL,
	[GUID] [nvarchar](100) NOT NULL,
	[Name] [nvarchar](256) NOT NULL,
	[MajorVersion] [int] NOT NULL,
	[MinorVersion] [int] NOT NULL,
	[Content] [ntext] NOT NULL,
	[DataConnections] [ntext] NOT NULL,
	[CreationDate] [datetime] NOT NULL,
	[Description] [ntext] NULL,
	[Author] [nvarchar](256) NULL,
	[Context] [nvarchar](100) NULL,
	[Comment] [ntext] NULL,
   CONSTRAINT [PK_WSFieldPack] PRIMARY KEY CLUSTERED 
   (
	[ID] ASC
   ) WITH (PAD_INDEX = OFF, 
           STATISTICS_NORECOMPUTE = OFF, 
           IGNORE_DUP_KEY = OFF, 
           ALLOW_ROW_LOCKS = ON, 
           ALLOW_PAGE_LOCKS = ON) 
     ON [PRIMARY],
   CONSTRAINT [UQ_IDVERSION] UNIQUE NONCLUSTERED
   (
        [GUID], [MajorVersion], [MinorVersion], [Context]
   )
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVSERVICESANITY] (
	[ProcessId] [bigint] NOT NULL , 
	[InternalTag] [int] NOT NULL , 
	[SVServiceId] [bigint] NOT NULL ,
	PRIMARY KEY ([ProcessId], [InternalTag])
        ) ON [PRIMARY]
GO
CREATE TABLE [dbo].[WFACTDEF] (
	[Name] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[PROCID] [bigint] NOT NULL ,
	[InternalTag] [int] NOT NULL ,
	[Description] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Duration] [int] NOT NULL ,
	[SendDelay] [int] NOT NULL DEFAULT 0,
	[Type] [int] NULL ,
	[Performer] [nvarchar] (126) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[isApproval] [int] NOT NULL ,
	[isTeam] [int] NOT NULL ,
	[LoopType] [int] NULL ,
	[Condition] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[BlockID] [int] NULL ,
	[ApprovalType] [int] NULL ,
	[VoteCount] [int] NULL ,
	[Reminder] [int] NOT NULL ,
	[NotificationMessage] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Disposition] [int] NULL ,
	[PluginName] [nvarchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[PluginAssembly] [nvarchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[PluginClass] [nvarchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[PluginMode] [int] NULL ,
	[PluginArgs] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Options] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[FormView] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[HiddenFields] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[HiddenFieldType] [smallint] NOT NULL ,
	[AllowReassign] [int] NOT NULL DEFAULT 1 ,
	[AllowAddTeam] [int] NOT NULL DEFAULT 1,
	[AllowReplace] [int] NOT NULL DEFAULT 0,
	[RequireReview] [int] NOT NULL DEFAULT 0,
	[DefaultPeriod] [int] NOT NULL DEFAULT 0,
	[CommentRequirement] [smallint] NOT NULL,
	[EMailEnable] [int] NOT NULL DEFAULT 0,
	[EmailFormattingType] [int] NOT NULL DEFAULT 0,
	[IncludeItem] [int] NOT NULL DEFAULT 0,
	[LinkOption] [int] NOT NULL DEFAULT 0,
	[MainPageLinkOption] [int] NOT NULL DEFAULT 1,
	[AssignmentCompletionLinkOption] [int] NOT NULL DEFAULT 0,
	[HistoryOption] [int] NOT NULL DEFAULT 1,
	[MainPageLinkText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ItemLinkText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[AssignmentCompletionLinkText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[SetParms] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[OverrideDurarion] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[OverrideSendDelay] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[OverdueReminderFrequency] [int] NOT NULL DEFAULT 0,
	[SendReminderEmail] [int] NOT NULL DEFAULT 1,
	[SendPastDueEmail] [int] NOT NULL DEFAULT 1,
	[SendCancellationEmail] [int] NOT NULL DEFAULT 1,
	[SendAssignmentEmail] [int] NOT NULL DEFAULT 1,
	[AllowBulkApproval] [int] NOT NULL DEFAULT 0,
	[SendDefaultApprovalEmail] [int] NOT NULL DEFAULT 1,
	[LinkOrder] [smallint] NOT NULL DEFAULT 1,
	[FormAttachmentFormat] [nvarchar] (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ItemLevelPermissions] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ItemLevelPermissionsType] [smallint] NOT NULL DEFAULT 0,
	[PastDueEmailCC] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ApproveDispText] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[RejectDispText] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFACTIVITYTYPE] (
	[Code] [int] NOT NULL ,
	[Description] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFASSIGNMENT] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[InternalTag] [int] NOT NULL ,
	[ProcessId] [bigint] NOT NULL ,
	[AssignedDate] [datetime] NULL ,
	[DueDate] [datetime] NULL ,
	[ReviewDate] [datetime] NULL ,
	[CompletedDate] [datetime] NULL ,
	[Status] [int] NOT NULL ,
	[Actor] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Note] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[History] [int] NOT NULL ,
	[BlockID] [int] NULL ,
	[ReminderNotified] [int] NOT NULL ,
	[LateNotified] [int] NOT NULL ,
	[SeqNo] [nvarchar] (32) NOT NULL ,
	[TimeStamp] [timestamp] NOT NULL ,
	[UserData] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[UserId] [int] NOT NULL DEFAULT 0 ,
	[AutoApproved] [int] NOT NULL DEFAULT 0,
	[Disposition] [varchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFASSIGNMENTSTATUS] (
	[Code] [int] NOT NULL ,
	[Description] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFATTRIBUTE] (
	[ProcId] [bigint] NOT NULL ,
	[Name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Type] [int] NOT NULL ,
	[AttrValue] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Id] [bigint] IDENTITY (1, 1) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFATTRIBUTEDEF] (
	[Name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Type] [int] NOT NULL ,
	[DefaultValue] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ProcID] [bigint] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFMANAGEDATTR] (
	[Attribute] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ActivityID] [bigint] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFPERFORMER] (
	[ProcId] [bigint] NOT NULL ,
	[Name] [nvarchar] (128) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Email] [nvarchar] (128) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[UserId] [bigint] NULL ,
	[FullName] [nvarchar] (128) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[PerformerDefName] [nvarchar] (128) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[LookupKey] [nvarchar] (128) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[OriginalProcId] [bigint] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFPERFORMERDEF] (
	[Name] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Description] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Type] [smallint] NOT NULL ,
	[Team] [smallint] NOT NULL ,
	[RoleID] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[UserID] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[TaskID] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ProcDefID] [bigint] NOT NULL ,
	[SelfIncluded] [int] NOT NULL DEFAULT 1 ,
	[RoleResolution] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[RoleResolutionArguments] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Options] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFPROCDEF] (
	[Name] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Description] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Version] [int] NOT NULL ,
	[Status] [int] NOT NULL ,
	[Duration] [int] NOT NULL ,
	[CreationDate] [datetime] NULL ,
	[Author] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[LastActivityCount] [int] NOT NULL ,
	[Context] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Context2] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Design] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[AssignText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[PastDueText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[CancellationText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ReminderText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ExceptionText] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[DocOrForm] [nvarchar] (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ContextPath] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ProcessType] [int] NOT NULL ,
	[AssignStyle] [int] NOT NULL ,
	[GroupName] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[EMailEnable] [int] NOT NULL DEFAULT 0 ,
	[SignatureEnabled] [int] NOT NULL DEFAULT 0 ,
	[ChallengeOnApproval] [int] NOT NULL DEFAULT 0,
	[AssignByEmail] [int] NOT NULL DEFAULT 1 ,
	[EngineVersion] [int] NOT NULL DEFAULT 2 ,
	[SharePointTaskList] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[SharePointTaskListSite] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ShareVisProcessStatusList] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ShareVisAssignmentStatusList] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ShareVisStatusListSite] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[OverrideDuration] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ListType] [int] NOT NULL DEFAULT 0,
	[WorkflowGraphicPackage] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[AutoLaunchOnCreate] [int] NOT NULL DEFAULT 0,
	[AutoLaunchOnEdit] [int] NOT NULL DEFAULT 0,
	[AutoLaunchOnCheckIn] [int] NOT NULL DEFAULT 0,
	[AutoLaunchOnEditColumns] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[AutoAttachedDocumentSite] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[AutoAttachedDocumentList] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFPROCESS] (
	[Name] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[CreationDate] [datetime] NOT NULL ,
	[DueDate] [datetime] NULL ,
	[DefName] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[DefId] [bigint] NOT NULL ,
	[Originator] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[CompletionDate] [datetime] NULL ,
	[Status] [int] NOT NULL ,
	[ReferenceId] [nvarchar] (225) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ReferenceId2] [nvarchar] (225) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[LastApprover] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[TimeStamp] [timestamp] NOT NULL ,
	[SeqNo] [bigint] NOT NULL ,
	[MiscInfo] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[FullPath] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Salt] [binary] (256) NULL ,
	[Signature] [char] (28) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ParentProcessId] [bigint] NOT NULL DEFAULT 0,
	[ParentNodeIntTag] [int] NOT NULL DEFAULT 0,
	[InheritanceLabel] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Inactive] [smallint] NOT NULL DEFAULT 0,
	[Note] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[IsForced] [nvarchar] (3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[TaskItemTitle] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ItemXml] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[ArchivalStatus] [int] DEFAULT 2
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFPROCESSSTATUS] (
	[Code] [int] NOT NULL ,
	[Description] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFTRANSDEF] (
	[Name] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[FromTag] [int] NOT NULL ,
	[ToTag] [int] NOT NULL ,
	[Condition] [ntext] NULL ,
	[PROCID] [bigint] NOT NULL ,
	[ID] [bigint] IDENTITY (1, 1) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFMAIL] (
	[MailServer] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Recipient] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Sender] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Body] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Subject] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Style] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVSERVICE] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Type] [nvarchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[AssemblyName] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ClassName] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Status] [int] NOT NULL ,
	[StartDate] [datetime] NULL ,
	[CompletionDate] [datetime] NULL ,
	[ProcessingDate] [datetime] NULL ,
	[ProcessingHost] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Xml] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Error] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ReferenceKey] [bigint] NOT NULL DEFAULT 0 ,
	[Owner] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[TimeStamp] [timestamp] NOT NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVConfig] (
	[SiteGUID] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[WebGUID] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ListGUID] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ParmName] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ParmValue] [nvarchar] (2560) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ParmScope] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVSPListItem](
	[WebAppGUID] [uniqueidentifier] NOT NULL,	
	[SiteGUID] [uniqueidentifier] NOT NULL,
	[WebGUID] [uniqueidentifier] NOT NULL,
	[ListID] [uniqueidentifier] NOT NULL,
	[ListModifedTime] [datetime] NOT NULL,
	[ListName] [varchar](max) NOT NULL,
	[ReferenceId] [varchar](50) NOT NULL,
	[Title] [varchar](max) NOT NULL,
	[SVVersion] [int] NOT NULL,
	[SVDescription] [varchar](max) NOT NULL,
	[CreationDate] [datetime] NOT NULL,
	[CreatedBy] [nvarchar](400) NOT NULL,
	[TimeStamp] [datetime] NOT NULL,
	[ReadyForUse] [bit] NOT NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[SVSPListItem] ADD  CONSTRAINT [DF_SVSPListItem_ReadyForUse]  DEFAULT ((0)) FOR [ReadyForUse]
GO

CREATE NONCLUSTERED INDEX [IX_SVSPListItem] ON [dbo].[SVSPListItem] 
(
	[ListID] ASC,
	[ReadyForUse] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_SVSPListItem_CreatedBy] ON [dbo].[SVSPListItem] 
(
	[CreatedBy] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_SVSPListItem_ReferenceID] ON [dbo].[SVSPListItem] 
(
	[ReferenceId] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_SVSPListItem_CreationDate] ON [dbo].[SVSPListItem] 
(
	[CreationDate] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFSUBPROCREG] (
	[SubProcessId] [bigint] NOT NULL ,
	[NodeTag] [int] NOT NULL ,
	[ProcessId] [bigint] NOT NULL ,
	[ReturnValue] [nchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[CreationDate] [datetime] NOT NULL ,
	[CompleteDate] [datetime] NULL ,
	[Status] [int] NOT NULL ,
	[ID] [bigint] IDENTITY (1, 1) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFDELEGATION] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Ordinal] [bigint] NOT NULL DEFAULT 0 ,
	[UserKey] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[FromDate] [datetime] NOT NULL ,
	[EndDate] [datetime] NOT NULL ,
	[DelegateLoginName] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[DelegateFullName] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[DelegateEmail] [nvarchar] (516) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Active] [int] NOT NULL DEFAULT 1 ,
	[Type] [int] NOT NULL DEFAULT 0 ,
	[K] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[V] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
) ON [PRIMARY]
GO

 CREATE  CLUSTERED  INDEX [UserKeyIndex] ON [dbo].[WFDELEGATION]([UserKey]) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WFACTORGROUP] (
	[ProcessDefId] [bigint] NOT NULL ,
	[GroupName] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[RoleName] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ActorLogin] [nvarchar] (512) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVItemProperty] (
	[Type] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ReferenceId] [nvarchar] (225) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[K] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[V] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[CreateDate] [datetime] NOT NULL ,
	[Misc] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL DEFAULT ''
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVNAMEGEN] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Name] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Template] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[SeedValue] [nvarchar] (256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[TStamp] [timestamp] NOT NULL ,
	[SiteGuid] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[WebGuid] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVExternalEvent](
	[ServiceID] [bigint] NOT NULL,
	[ExternalID] [bigint] NOT NULL,
	[Name] [nvarchar](100) NOT NULL,
	[SubmittedDate] [datetime] NOT NULL,
	[CompletedDate] [datetime] NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[SVExternalEvent] ADD  CONSTRAINT [DF_SVExternalEvent_SubmittedDate]  DEFAULT (getdate()) FOR [SubmittedDate]
GO

CREATE UNIQUE NONCLUSTERED INDEX [IX_SVExternalEvent_ExternalID] ON [dbo].[SVExternalEvent]
(
	[ExternalID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_SVExternalEvent_ServiceID] ON [dbo].[SVExternalEvent]
(
	[ServiceID] ASC,
	[Name] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVEvent] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ReferenceId] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Type] [smallint] NOT NULL ,
	[Status] [smallint] NOT NULL ,
	[AssemblyName] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ClassName] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Xml] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Error] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVAssignment] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Name] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Description] [nvarchar] (500) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[SiteGuid] [char] (36) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[WebGuid] [char] (36) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ReferenceId] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[AssignedDate] [datetime] NULL ,
	[DueDate] [datetime] NULL ,
	[CompletedDate] [datetime] NULL ,
	[Status] [smallint] NOT NULL ,
	[Assignee] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[AssemblyName] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ClassName] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Handler] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[SVNAMEGEN] ADD 
	CONSTRAINT [IX_SVNAMEGEN_1] UNIQUE  NONCLUSTERED 
	(
		[Name],
		[WebGuid]
	)  ON [PRIMARY] 
GO

CREATE INDEX [IX_SVITEMPROPERTY] ON [dbo].[SVItemProperty]([ReferenceId],[K]) ON [PRIMARY]
GO

CREATE INDEX [IX_SVASSIGNMENT] ON [dbo].[SVAssignment]([Assignee],[Status]) ON [PRIMARY]
GO

CREATE  INDEX [IX_SVNAMEGEN] ON [dbo].[SVNAMEGEN]([ID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[WFSUBPROCREG] ADD 
	CONSTRAINT [DF_WFSUBPROCREG_SubProcessId] DEFAULT (0) FOR [SubProcessId],
	CONSTRAINT [DF_WFSUBPROCREG_NodeTag] DEFAULT ((-1)) FOR [NodeTag],
	CONSTRAINT [DF_WFSUBPROCREG_ProcessId] DEFAULT (0) FOR [ProcessId],
	CONSTRAINT [DF_WFSUBPROCREG_Status] DEFAULT (0) FOR [Status]
GO

ALTER TABLE [dbo].[WFACTDEF] WITH NOCHECK ADD 
	CONSTRAINT [PK_WFACTDEF] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFASSIGNMENT] WITH NOCHECK ADD 
	CONSTRAINT [PK_WFASSIGNMENT] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFASSIGNMENTSTATUS] WITH NOCHECK ADD 
	CONSTRAINT [PK_WFASSIGNMENTSTATUS] PRIMARY KEY  CLUSTERED 
	(
		[Code]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFPROCDEF] WITH NOCHECK ADD 
	CONSTRAINT [PK_WFPROCDEF] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFPROCESS] WITH NOCHECK ADD 
	CONSTRAINT [PK_WFPROCESS] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFPROCESSSTATUS] WITH NOCHECK ADD 
	CONSTRAINT [PK_WFPROCESSSTATUS] PRIMARY KEY  CLUSTERED 
	(
		[Code]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFACTDEF] ADD 
	CONSTRAINT [DF_WFACTDEF_Duration] DEFAULT (24) FOR [Duration],
	CONSTRAINT [DF_WFACTDEF_Type] DEFAULT ((-1)) FOR [Type],
	CONSTRAINT [DF_WFACTDEF_isApproval] DEFAULT (0) FOR [isApproval],
	CONSTRAINT [DF_WFACTDEF_isTeam] DEFAULT (0) FOR [isTeam],
	CONSTRAINT [DF_WFACTDEF_Reminder] DEFAULT (0) FOR [Reminder]
GO

ALTER TABLE [dbo].[WFASSIGNMENT] ADD 
	CONSTRAINT [DF_WFASSIGNMENT_History] DEFAULT (0) FOR [History],
	CONSTRAINT [DF_WFASSIGNMENT_ReminderNotified] DEFAULT (0) FOR [ReminderNotified],
	CONSTRAINT [DF_WFASSIGNMENT_LateNotified] DEFAULT (0) FOR [LateNotified]
GO

ALTER TABLE [dbo].[WFPERFORMER] ADD 
	CONSTRAINT [DF_WFPERFORMER_OriginalProcId] DEFAULT (0) FOR [OriginalProcId]
GO

 CREATE  INDEX [IX_WFPERFORMER] ON [dbo].[WFPERFORMER]([PerformerDefName], [LookupKey]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_WFPERFORMER2] ON [dbo].[WFPERFORMER]([PerformerDefName], [ProcId]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_WFASSIGNMENT_ACTOR] ON [dbo].[WFASSIGNMENT]([Actor]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[WFPERFORMERDEF] ADD 
	CONSTRAINT [DF_WFPERFORMERDEF_Team] DEFAULT (0) FOR [Team]
GO

ALTER TABLE [dbo].[WFPROCDEF] ADD 
	CONSTRAINT [DF_WFPROCDEF_Version] DEFAULT (0) FOR [Version],
	CONSTRAINT [DF_WFPROCDEF_Status] DEFAULT (0) FOR [Status],
	CONSTRAINT [DF_WFPROCDEF_Duration] DEFAULT (24) FOR [Duration],
	CONSTRAINT [DF_WFPROCDEF_LastActivityCount] DEFAULT (0) FOR [LastActivityCount],
	CONSTRAINT [DF_WFPROCDEF_ProcessType] DEFAULT (0) FOR [ProcessType],
	CONSTRAINT [IX_WFPROCDEF] UNIQUE  NONCLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFPROCESS] ADD 
	CONSTRAINT [DF_WFPROCESS_Status] DEFAULT ((-1)) FOR [Status],
	CONSTRAINT [DF_WFPROCESS_SeqNo] DEFAULT (0) FOR [SeqNo],
	CONSTRAINT [DF_WFPROCESS_IsForced] DEFAULT (N'No') FOR [IsForced],
	CONSTRAINT [IX_WFPROCESS_1] UNIQUE  NONCLUSTERED 
	(
		[ReferenceId],
		[SeqNo]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WFASSIGNMENT] ADD 
	CONSTRAINT [UN_WFASSIGNMENT] UNIQUE  NONCLUSTERED 
	(
		[ProcessId],
		[SeqNo]
	)  ON [PRIMARY] 
GO

 CREATE  UNIQUE  INDEX [IX_WFPROCESS] ON [dbo].[WFPROCESS]([ID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_WFPROCESS_2] ON [dbo].[WFPROCESS]([ReferenceId], [ReferenceId2]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_SVSERVICE] ON [dbo].[SVSERVICE]([StartDate], [Status]) ON [PRIMARY]
GO

 CREATE INDEX [IX_WFPROCESS_INHERITANCE] ON [dbo].[WFPROCESS] ([ParentProcessId], [InheritanceLabel])
GO

CREATE INDEX [IX_WFPROCESS_VIEW] ON [dbo].[WFPROCESS] ([Status], [Inactive], [Originator]) ON [PRIMARY]
GO

CREATE INDEX [IX_SVEvent_ReferenceId_Type] ON [dbo].[SVEvent]([ReferenceId], [Type]) ON [PRIMARY]
GO

 CREATE INDEX [IX_WFSUBPROCREG_PROCESSID] ON [dbo].[WFSUBPROCREG]([ProcessId]) ON [PRIMARY]
GO

 CREATE INDEX [IX_WFMANAGEDATTR_ACTIVITYID] ON [dbo].[WFMANAGEDATTR]([ActivityId]) ON [PRIMARY]
GO

 CREATE INDEX [IX_WFTRANSDEF_PROCID] ON [dbo].[WFTRANSDEF]([ProcId]) ON [PRIMARY]
GO

 CREATE INDEX [IX_WFPERFORMERDEF_PROCDEFID] ON [dbo].[WFPERFORMERDEF]([ProcDefId]) ON [PRIMARY]
GO

 CREATE INDEX [IX_WFATTRIBUTEDEF_PROCID] ON [dbo].[WFATTRIBUTEDEF]([ProcId]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[WFSUBPROCREG] ADD 
	CONSTRAINT [FK_WFSUBPROCREG_WFPROCESS] FOREIGN KEY 
	(
		[ProcessId]
	) REFERENCES [dbo].[WFPROCESS] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFACTDEF] ADD 
	CONSTRAINT [FK_WFACTDEF_WFPROCDEF] FOREIGN KEY 
	(
		[PROCID]
	) REFERENCES [dbo].[WFPROCDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFASSIGNMENT] ADD 
	CONSTRAINT [FK_WFASSIGNMENT_WFASSIGNMENTSTATUS] FOREIGN KEY 
	(
		[Status]
	) REFERENCES [dbo].[WFASSIGNMENTSTATUS] (
		[Code]
	),
	CONSTRAINT [FK_WFASSIGNMENT_WFPROCESS] FOREIGN KEY 
	(
		[ProcessId]
	) REFERENCES [dbo].[WFPROCESS] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFATTRIBUTE] ADD 
	CONSTRAINT [FK_WFATTRIBUTE_WFPROCESS] FOREIGN KEY 
	(
		[ProcId]
	) REFERENCES [dbo].[WFPROCESS] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

CREATE  INDEX [IX_WFATTRIBUTE_PROCID] ON [dbo].[WFATTRIBUTE]([PROCID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[WFATTRIBUTEDEF] ADD 
	CONSTRAINT [FK_WFATTRIBUTEDEF_WFPROCDEF] FOREIGN KEY 
	(
		[ProcID]
	) REFERENCES [dbo].[WFPROCDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFMANAGEDATTR] ADD 
	CONSTRAINT [FK_WFMANAGEDATTR_WFACTDEF] FOREIGN KEY 
	(
		[ActivityID]
	) REFERENCES [dbo].[WFACTDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFPERFORMER] ADD 
	CONSTRAINT [FK_WFPERFORMER_WFPROCESS] FOREIGN KEY 
	(
		[ProcId]
	) REFERENCES [dbo].[WFPROCESS] (
		[ID]
	),
	CONSTRAINT [FK_WFPERFORMER_WFPROCESS2] FOREIGN KEY 
	(
		[OriginalProcId]
	) REFERENCES [dbo].[WFPROCESS] (
		[ID]
	)
GO

alter table [dbo].[WFPERFORMER] nocheck constraint [FK_WFPERFORMER_WFPROCESS]
GO

ALTER TABLE [dbo].[WFPERFORMERDEF] ADD 
	CONSTRAINT [FK_WFPERFORMERDEF_WFPROCDEF] FOREIGN KEY 
	(
		[ProcDefID]
	) REFERENCES [dbo].[WFPROCDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFPROCESS] ADD 
	CONSTRAINT [FK_WFPROCESS_WFPROCDEF] FOREIGN KEY 
	(
		[DefId]
	) REFERENCES [dbo].[WFPROCDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE ,
	CONSTRAINT [FK_WFPROCESS_WFPROCESSSTATUS] FOREIGN KEY 
	(
		[Status]
	) REFERENCES [dbo].[WFPROCESSSTATUS] (
		[Code]
	)
GO

ALTER TABLE [dbo].[WFTRANSDEF] ADD 
	CONSTRAINT [FK_WFTRANSDEF_WFPROCDEF] FOREIGN KEY 
	(
		[PROCID]
	) REFERENCES [dbo].[WFPROCDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

ALTER TABLE [dbo].[WFACTORGROUP] ADD 
	CONSTRAINT [FK_WFACTORGROUP_WFPROCDEF] FOREIGN KEY 
	(
		[ProcessDefId]
	) REFERENCES [dbo].[WFPROCDEF] (
		[ID]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

CREATE TABLE [dbo].[WSServiceCaching] (
    [LastModified] [DateTime] default (Getdate()) NOT NULL,
    [ListGuid] [nvarchar] (68) NOT NULL,
	[ProcessName] [nvarchar] (512) NOT NULL,
	[Status] [smallint] NOT NULL DEFAULT 0)
GO

CREATE TABLE [dbo].[WSDLFiles] (
    [LastModified] [DateTime] default (Getdate()) NOT NULL,
    [FileName] [nvarchar] (255) NOT NULL,
	[ListGuid] [nvarchar] (68) NOT NULL,
	[ProcessName] [nvarchar] (512) NOT NULL,
	[WSDL] [xml] NOT NULL)
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetWSDL]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetWSDL]

 Go
CREATE Procedure [dbo].[ws_GetWSDL]
(
      @FileName nvarchar(255),
	  @ListGuid nvarchar(68),
	  @ProcessName nvarchar(512)
)
as
BEGIN
    SELECT WSDL From WSDLFiles
    WHERE FileName=@FileName and ListGuid=@ListGuid and ProcessName=@ProcessName 
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_InsertOrUpdateWSDL]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_InsertOrUpdateWSDL]
Go

CREATE Procedure [dbo].[ws_InsertOrUpdateWSDL]
(
      @FileName nvarchar(255),
	  @ListGuid nvarchar(68),
	  @ProcessName nvarchar(512),
	  @WSDL xml
)
as
     IF EXISTS (SELECT FileName From WSDLFiles 
     WHERE FileName=@FileName and ListGuid=@ListGuid and ProcessName=@ProcessName)
        BEGIN
              update WSDLFiles set WSDL=@WSDL, LastModified = GETDATE()
              WHERE FileName=@FileName and ListGuid=@ListGuid and ProcessName=@ProcessName 
        END
    ELSE
        BEGIN
              insert into WSDLFiles(FileName,ListGuid,ProcessName,WSDL)
              values(@FileName,@ListGuid,@ProcessName,@WSDL) 
        END
Go

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_UpdateProcessArchivalStatus]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_UpdateProcessArchivalStatus]
Go

CREATE Procedure [dbo].[ws_UpdateProcessArchivalStatus]
(
      @ProcessId bigint,
	  @ArchivalStatus int
)
as
        BEGIN
              update WFPROCESS set ArchivalStatus = @ArchivalStatus 
			  WHERE ID=@ProcessId 
        END
Go

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_ManageWebserviceCaching]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_ManageWebserviceCaching]
Go

CREATE Procedure [dbo].[ws_ManageWebserviceCaching]
(
      @ListGuid nvarchar(68),
	  @ProcessName nvarchar(512)
)
as
     IF EXISTS (SELECT LastModified From WSServiceCaching 
     WHERE ListGuid=@ListGuid and ProcessName=@ProcessName)
        BEGIN
              update WSServiceCaching set LastModified = GETDATE()
              WHERE ListGuid=@ListGuid and ProcessName=@ProcessName 
        END
    ELSE
        BEGIN
              insert into WSServiceCaching(ListGuid,ProcessName)
              values(@ListGuid,@ProcessName) 
        END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_RemoveCachingDetails]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_RemoveCachingDetails]
Go

CREATE Procedure [dbo].[ws_RemoveCachingDetails]
(
      @ListGuid nvarchar(68),
	  @ProcessName nvarchar(512)
)
as
        BEGIN
              delete from WSServiceCaching
              WHERE ListGuid=@ListGuid and ProcessName=@ProcessName  
        END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetProcessTimeStamp]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetProcessTimeStamp]
Go

CREATE Procedure [dbo].[ws_GetProcessTimeStamp]
(
      @ListGuid nvarchar(68),
	  @ProcessName nvarchar(512)
)
as
BEGIN
      SELECT LastModified from WSServiceCaching
	  WHERE ListGuid=@ListGuid and ProcessName=@ProcessName and Status=0
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_RemoveWorkflowDetails]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_RemoveWorkflowDetails]
Go

CREATE Procedure [dbo].[ws_RemoveWorkflowDetails]
(
      @ListGuid nvarchar(68),
      @PurgeBefore datetime
)
as

BEGIN

SELECT distinct(ParentProcessId) into #ImmuneParents 
from WFPROCESS 
WHERE ParentProcessID != 0 AND Status IN(0,1,2);

SELECT ID into #ImmuneChildren 
from WFPROCESS 
WHERE ParentProcessID IN (SELECT ParentProcessId FROM #ImmuneParents UNION SELECT ID FROM WFPROCESS WHERE Status IN(0,1,2))

    SELECT ID, ReferenceId into #TEMPORARYTABLE
    from WFPROCESS
    where ReferenceId like @ListGuid + ';%' and ArchivalStatus = 0 and CompletionDate < @PurgeBefore
	
	DELETE FROM #TEMPORARYTABLE 
	WHERE ID IN(SELECT ParentProcessId from #ImmuneParents UNION SELECT ID from #ImmuneChildren)

    DELETE from SVASSIGNMENT 
    where ReferenceId in (select ReferenceId from #TEMPORARYTABLE)

    DELETE from SVEVENT 
    where ReferenceId in (select ReferenceId from #TEMPORARYTABLE)

    DELETE from SVITEMPROPERTY 
    where ReferenceId in (select ReferenceId from #TEMPORARYTABLE) and Type != 'ItemData'

    DELETE from WFASSIGNMENT
    where ProcessId in (select ID from #TEMPORARYTABLE)

    DELETE from WFPERFORMER 
    where ProcId in (select ID from #TEMPORARYTABLE)

    DELETE from WFPERFORMER 
    where OriginalProcId in (select ID from #TEMPORARYTABLE)

    DELETE from WFATTRIBUTE
    where ProcId in (select ID from #TEMPORARYTABLE)

    DELETE from WFPROCESS
    where ID in (select ID from #TEMPORARYTABLE)

   drop table #ImmuneChildren
   drop table #ImmuneParents
   drop table #TEMPORARYTABLE
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_SetArchivalStatus]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_SetArchivalStatus]
Go

CREATE Procedure [dbo].[ws_SetArchivalStatus]
(
      @WorkflowID bigint,
	  @SetStatus int
)
as
BEGIN
   update WFPROCESS set ArchivalStatus = @SetStatus where ID = @WorkflowID
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetPendingOrRunningJobs]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetPendingOrRunningJobs]
Go

CREATE Procedure [dbo].[ws_GetPendingOrRunningJobs]
(
      @JobType nvarchar(25)
)
as
BEGIN
   select Xml from SVSERVICE
   where Type = @JobType and status IN (1,4)
END
GO

CREATE TABLE [dbo].[SVItemKey] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Key0] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Key1] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Key2] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Key3] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Key4] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Date0] [datetime] NULL ,
	[Date1] [datetime] NULL ,
	[Value0] [bigint] NULL ,
	[Value1] [bigint] NULL ,
	[Type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ItemValueID] [bigint] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVItemValue] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ItemValue] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVPG] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[Name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Description] [nvarchar] (200) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[Site] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[CreationDate] [datetime] NOT NULL ,
	[StartDate] [datetime] NOT NULL ,
	[Xml] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SVBlobCacheEntry](
	[ID] [bigint] IDENTITY (1, 1) NOT NULL,
	[ModifiedDate] [datetime] NOT NULL,
	[Entry] [image] NOT NULL,
 CONSTRAINT [PK_SVBlobCacheEntry] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[SVItemKey] WITH NOCHECK ADD 
	CONSTRAINT [PK_SVItemKey] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SVItemValue] WITH NOCHECK ADD 
	CONSTRAINT [PK_ItemValue] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_SVItemKey] ON [dbo].[SVItemKey]([Type], [Key0], [Key1], [Key2], [Key3], [Key4]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_SVItemKey0] ON [dbo].[SVItemKey]([Type], [Key0]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_SVItemKey1] ON [dbo].[SVItemKey]([Type], [Key1]) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_SVBlobCacheEntryModifiedDate] ON [dbo].[SVBlobCacheEntry] 
(
	[ModifiedDate] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

ALTER TABLE [dbo].[SVItemKey] ADD 
	CONSTRAINT [FK_SVItemKey_SVItemValue] FOREIGN KEY 
	(
		[ItemValueID]
	) REFERENCES [dbo].[SVItemValue] (
		[ID]
	)
GO


SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AssignmentView]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[AssignmentView]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AssignmentView2]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[AssignmentView2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ProcessView]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[ProcessView]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.ProcessView
AS
SELECT     TOP 100 PERCENT dbo.WFPROCESS.Name AS ProcessName, dbo.WFPROCESS.ID AS ProcessId, dbo.WFPROCESS.CreationDate,
                      dbo.WFPROCESS.DueDate, dbo.WFPROCESS.DefId AS ProcessDefId, dbo.WFPROCESS.Originator, dbo.WFPROCESS.CompletionDate,
                      dbo.WFPROCESS.Status AS ProcessStatusCode, dbo.WFPROCESS.ReferenceId, dbo.WFPROCDEF.Name AS ProcessDefinitionName,
                      dbo.WFPROCDEF.Version AS ProcessDefinitionVersion, dbo.WFPROCDEF.Duration AS EstimateDuration, dbo.WFPROCDEF.Context,
                      dbo.WFPROCESSSTATUS.Description AS ProcessStatus, dbo.WFPROCESS.ReferenceId2, dbo.WFPROCESS.LastApprover,
		      dbo.WFPROCESS.TaskItemTitle, dbo.WFPROCESS.ItemXml, dbo.WFPROCESS.TimeStamp,
                      dbo.WFPROCDEF.ContextPath, dbo.WFPROCDEF.ProcessType, dbo.WFPROCESS.MiscInfo, dbo.WFPROCDEF.Context2, dbo.WFPROCDEF.Status,
                      dbo.WFPROCDEF.Description, dbo.WFPROCDEF.DocOrForm, dbo.WFPROCESS.ParentProcessId, dbo.WFPROCESS.InheritanceLabel,
                      dbo.WFPROCESS.Note, dbo.WFPROCESS.IsForced, dbo.WFPROCDEF.CreationDate AS ProcessDefinitionCreationDate,
		      dbo.WFPROCDEF.Author
FROM         dbo.WFPROCESS INNER JOIN
                      dbo.WFPROCDEF ON dbo.WFPROCESS.DefId = dbo.WFPROCDEF.ID INNER JOIN
                      dbo.WFPROCESSSTATUS ON dbo.WFPROCESS.Status = dbo.WFPROCESSSTATUS.Code
WHERE     (dbo.WFPROCESS.Inactive = 0)
ORDER BY dbo.WFPROCESS.CreationDate DESC

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE VIEW dbo.AssignmentView
AS
SELECT     TOP 100 PERCENT dbo.WFASSIGNMENT.ID AS AssignmentId, dbo.WFPROCESS.Originator, dbo.WFACTDEF.Type AS AssignmentType,
                      dbo.WFACTIVITYTYPE.Description AS AssignmentTypeDescription,
                      dbo.WFASSIGNMENT.InternalTag AS AssignmentTag, dbo.WFASSIGNMENT.Status AS AssignmentStatusCode, dbo.WFASSIGNMENT.AssignedDate, 
                      dbo.WFASSIGNMENT.DueDate, dbo.WFASSIGNMENT.CompletedDate AS CompletionDate, dbo.WFASSIGNMENT.ReviewDate, 
                      dbo.WFASSIGNMENT.Actor AS AssignmentActor, dbo.WFASSIGNMENT.Note AS AssignmentNote, 
                      dbo.WFASSIGNMENTSTATUS.Description AS AssignmentStatus, dbo.WFASSIGNMENT.ProcessId, dbo.WFASSIGNMENT.History AS HistoryFlag, 
                      dbo.WFPROCDEF.Context, dbo.WFPROCESS.ReferenceId, dbo.WFPROCDEF.Name AS ProcessDefName, dbo.WFPROCESS.Name AS ProcessName, 
                      dbo.WFPROCDEF.ID AS ProcessDefId, dbo.WFPROCESS.ReferenceId2, dbo.WFPROCESS.LastApprover, dbo.WFACTDEF.Reminder AS ReminderCount, 
                      dbo.WFASSIGNMENT.ReminderNotified, dbo.WFACTDEF.Duration AS EstimateDuration, dbo.WFASSIGNMENT.LateNotified, 
                      dbo.WFACTDEF.Name AS ActivityName, dbo.WFACTDEF.BlockID AS LoopOwner, dbo.WFPROCESS.CreationDate, dbo.WFPROCDEF.ContextPath, 
		      dbo.WFACTDEF.FormView, dbo.WFACTDEF.CommentRequirement, dbo.WFAssignment.AutoApproved,
                      dbo.WFPROCDEF.ProcessType, dbo.WFPROCDEF.Context2, dbo.WFACTDEF.DefaultPeriod, dbo.WFPROCESS.ParentProcessId, 
                      dbo.WFPROCDEF.DocOrForm, dbo.WFACTDEF.RequireReview, dbo.WFACTDEF.AllowBulkApproval,
		      dbo.WFACTDEF.AllowReassign, dbo.WFACTDEF.AllowAddTeam, dbo.WFACTDEF.AllowReplace,
		      dbo.WFACTDEF.EMailEnable AS AllowEmailApproval,
		      dbo.WFASSIGNMENT.Disposition AS AssignmentDisposition,
                      dbo.WFPROCESS.TaskItemTitle,
                      dbo.WFPROCESS.InheritanceLabel, dbo.WFACTDEF.Description AS ActivityDesc, dbo.WFACTDEF.ID AS ActivityDefId, 
                      dbo.WFPROCESS.DueDate AS ProcessDueDate, dbo.WFPROCESS.CompletionDate AS ProcessCompletionDate, 
                      dbo.WFPROCESS.Status AS ProcessStatus, dbo.WFASSIGNMENT.UserData, dbo.WFPROCESS.MiscInfo, 
                      dbo.WFACTDEF.Performer AS PerformerDefName, dbo.WFPROCESSSTATUS.Description AS ProcessStatusName
FROM         dbo.WFASSIGNMENT INNER JOIN
                      dbo.WFPROCESS ON dbo.WFASSIGNMENT.ProcessId = dbo.WFPROCESS.ID INNER JOIN
                      dbo.WFPROCDEF ON dbo.WFPROCESS.DefId = dbo.WFPROCDEF.ID INNER JOIN
                      dbo.WFACTDEF ON dbo.WFPROCDEF.ID = dbo.WFACTDEF.PROCID AND dbo.WFASSIGNMENT.InternalTag = dbo.WFACTDEF.InternalTag INNER JOIN
                      dbo.WFASSIGNMENTSTATUS ON dbo.WFASSIGNMENT.Status = dbo.WFASSIGNMENTSTATUS.Code INNER JOIN
                      dbo.WFPROCESSSTATUS ON dbo.WFPROCESS.Status = dbo.WFPROCESSSTATUS.Code INNER JOIN
		      dbo.WFACTIVITYTYPE ON dbo.WFACTDEF.Type = dbo.WFACTIVITYTYPE.Code
WHERE        dbo.WFPROCESS.Inactive = 0
ORDER BY dbo.WFASSIGNMENT.AssignedDate DESC


GO

CREATE VIEW dbo.AssignmentView2
AS
SELECT     TOP 100 PERCENT dbo.WFASSIGNMENT.ID AS AssignmentId, dbo.WFPROCESS.Originator, dbo.WFACTDEF.Type AS AssignmentType,
                      dbo.WFACTIVITYTYPE.Description AS AssignmentTypeDescription,
                      dbo.WFASSIGNMENT.InternalTag AS AssignmentTag, dbo.WFASSIGNMENT.Status AS AssignmentStatusCode, dbo.WFASSIGNMENT.AssignedDate,
                      dbo.WFASSIGNMENT.DueDate, dbo.WFASSIGNMENT.CompletedDate AS CompletionDate, dbo.WFASSIGNMENT.ReviewDate,
                      dbo.WFASSIGNMENT.Actor AS AssignmentActor, dbo.WFASSIGNMENT.Note AS AssignmentNote,
                      dbo.WFASSIGNMENTSTATUS.Description AS AssignmentStatus, dbo.WFASSIGNMENT.ProcessId, dbo.WFASSIGNMENT.History AS HistoryFlag,
                      dbo.WFPROCDEF.Context, dbo.WFPROCESS.ReferenceId, dbo.WFPROCDEF.Name AS ProcessDefName, dbo.WFPROCESS.Name AS ProcessName,
                      dbo.WFPROCDEF.ID AS ProcessDefId, dbo.WFPROCESS.ReferenceId2, dbo.WFPROCESS.LastApprover, dbo.WFACTDEF.Reminder AS ReminderCount,
                      dbo.WFASSIGNMENT.ReminderNotified, dbo.WFACTDEF.Duration AS EstimateDuration, dbo.WFASSIGNMENT.LateNotified,
                      dbo.WFACTDEF.Name AS ActivityName, dbo.WFACTDEF.BlockID AS LoopOwner, dbo.WFPROCESS.CreationDate, dbo.WFPROCDEF.ContextPath,
		      dbo.WFACTDEF.FormView, dbo.WFACTDEF.CommentRequirement, dbo.WFAssignment.AutoApproved,
                      dbo.WFPROCDEF.ProcessType, dbo.WFPROCDEF.Context2, dbo.WFACTDEF.DefaultPeriod, dbo.WFPROCESS.ParentProcessId,
                      dbo.WFPROCDEF.DocOrForm, dbo.WFACTDEF.RequireReview, dbo.WFACTDEF.AllowBulkApproval,
		      dbo.WFACTDEF.AllowReassign, dbo.WFACTDEF.AllowAddTeam, dbo.WFACTDEF.AllowReplace,
		      dbo.WFACTDEF.EMailEnable AS AllowEmailApproval,
		      dbo.WFASSIGNMENT.Disposition AS AssignmentDisposition,
                      dbo.WFPROCESS.TaskItemTitle,
                      dbo.WFPROCESS.InheritanceLabel, dbo.WFACTDEF.Description AS ActivityDesc, dbo.WFACTDEF.ID AS ActivityDefId,
                      dbo.WFPROCESS.DueDate AS ProcessDueDate, dbo.WFPROCESS.CompletionDate AS ProcessCompletionDate,
                      dbo.WFPROCESS.Status AS ProcessStatus, dbo.WFASSIGNMENT.UserData, dbo.WFPROCESS.MiscInfo,
                      dbo.WFACTDEF.Performer AS PerformerDefName, dbo.WFPROCESSSTATUS.Description AS ProcessStatusName
FROM         dbo.WFASSIGNMENT WITH (NOLOCK) INNER JOIN
                      dbo.WFPROCESS ON dbo.WFASSIGNMENT.ProcessId = dbo.WFPROCESS.ID INNER JOIN
                      dbo.WFPROCDEF ON dbo.WFPROCESS.DefId = dbo.WFPROCDEF.ID INNER JOIN
                      dbo.WFACTDEF ON dbo.WFPROCDEF.ID = dbo.WFACTDEF.PROCID AND dbo.WFASSIGNMENT.InternalTag = dbo.WFACTDEF.InternalTag INNER JOIN
                      dbo.WFASSIGNMENTSTATUS ON dbo.WFASSIGNMENT.Status = dbo.WFASSIGNMENTSTATUS.Code INNER JOIN
                      dbo.WFPROCESSSTATUS ON dbo.WFPROCESS.Status = dbo.WFPROCESSSTATUS.Code INNER JOIN
		      dbo.WFACTIVITYTYPE ON dbo.WFACTDEF.Type = dbo.WFACTIVITYTYPE.Code
WHERE        dbo.WFPROCESS.Inactive = 0
ORDER BY dbo.WFASSIGNMENT.AssignedDate DESC

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

SET ANSI_PADDING ON
GO

CREATE TABLE [dbo].[WSSLN](
	[SolutionID] [int] IDENTITY(1,1) NOT NULL,
	[ProcessDefinitionID] [int] NOT NULL,
	[FormReference] [varchar](100) NOT NULL,
	[Name] [nvarchar](100) NOT NULL,
	[SolutionXML] [ntext] NOT NULL,
	[FileContent] [image] NOT NULL,
	[CreatedOn] [datetime] NOT NULL,
	[Visible] [bit] NOT NULL,
 CONSTRAINT [PK_WSSLN] PRIMARY KEY CLUSTERED
(
	[SolutionID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

ALTER TABLE [dbo].[WSSLN] ADD  CONSTRAINT [DF_WSSLN_CreatedOn]  DEFAULT (getdate()) FOR [CreatedOn]
GO

ALTER TABLE [dbo].[WSSLN] ADD  CONSTRAINT [DF_WSSLN_Visible]  DEFAULT ((1)) FOR [Visible]
GO

CREATE NONCLUSTERED INDEX [IX_WSSLN_FORMREFERENCE] ON [dbo].[WSSLN] 
(
	[FormReference] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX_WSSLN_PROCESSDEFINITIONID] ON [dbo].[WSSLN] 
(
	[ProcessDefinitionID] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(1, 'Start')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(2, 'End')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(3, 'Task')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(4, 'Approval')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(5, 'Decision')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(6, 'Notification')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(7, 'And Join')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(8, 'Xor Join')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(9, 'Loop')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(10, 'Plug-In')
go
INSERT INTO [WFACTIVITYTYPE]([Code], [Description])
VALUES(11, 'Set')
go

INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(0, 'Draft')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(1, 'Assigned')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(2, 'Active')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(3, 'Completed')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(4, 'Approved')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(5, 'Rejected')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(6, 'Cancelled')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(7, 'Pending')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(8, 'Blocked')
go
INSERT INTO [WFASSIGNMENTSTATUS]([Code], [Description])
VALUES(9, 'ReAssigned')
go

INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(1, 'Draft')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(2, 'Running')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(3, 'Completed')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(4, 'Cancelled')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(5, 'Approved')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(6, 'Rejected')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(7, 'Blocked')
go
INSERT INTO [WFPROCESSSTATUS]([Code], [Description])
VALUES(0, 'Undefined')
go

if exists(select assemblyname from svservice where type = 'assignmentsummary' and AssemblyName not like '%Version={<WinshuttleWorkflow_AssemblyVersion>}%')
delete from [SVSERVICE] where type = 'assignmentsummary'
go

if not exists(select assemblyname from svservice where type = 'assignmentsummary')
INSERT INTO [SVSERVICE] ([Type],[AssemblyName],[ClassName],[Status],[StartDate],[Xml]) VALUES ('assignmentsummary', 'ShareVis, Version={<WinshuttleWorkflow_AssemblyVersion>}, Culture=neutral, PublicKeyToken=404db1d4cac98e68', 'ShareVis.Service.AssignmentSummaryNotificationExecutor', 1, '3/5/2006 9:53:39 AM', '<?xml version="1.0" encoding="utf-16"?><AssignmentSummaryNotificationExecutor xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"></AssignmentSummaryNotificationExecutor>')
go

if exists(select assemblyname from svservice where type = 'emailapproval' and AssemblyName not like '%Version={<WinshuttleWorkflow_AssemblyVersion>}%')
delete from [SVSERVICE] where type = 'emailapproval'
go

if not exists(select assemblyname from svservice where type = 'emailapproval')
INSERT INTO [SVSERVICE] ([Type],[AssemblyName],[ClassName],[Status],[StartDate],[Xml]) VALUES ('emailapproval', 'ShareVis, Version={<WinshuttleWorkflow_AssemblyVersion>}, Culture=neutral, PublicKeyToken=404db1d4cac98e68', 'ShareVis.Service.EMailApprovalExecutor', 1, '3/5/2006 9:53:39 AM', '<?xml version="1.0" encoding="utf-16"?><EMailApprovalExecutor xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><Interval>1</Interval></EMailApprovalExecutor>')
go

if exists(select assemblyname from svservice where type = 'offlineformprocessor' and AssemblyName not like '%Version={<WinshuttleWorkflow_AssemblyVersion>}%')
delete from [SVSERVICE] where type = 'offlineformprocessor'
go

if not exists(select assemblyname from svservice where type = 'offlineformprocessor')
INSERT INTO [SVSERVICE] ([Type],[AssemblyName],[ClassName],[Status],[StartDate],[Xml]) VALUES ('offlineformprocessor', 'ShareVis, Version={<WinshuttleWorkflow_AssemblyVersion>}, Culture=neutral, PublicKeyToken=404db1d4cac98e68', 'ShareVis.Service.OfflineFormProcessorExecutor', 1, '3/5/2006 9:53:39 AM', '<?xml version="1.0" encoding="utf-16"?><OfflineFormProcessorExecutor xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"></OfflineFormProcessorExecutor>')
go

if exists(select assemblyname from svservice where type = 'createmhtfile' and AssemblyName not like '%Version={<WinshuttleWorkflow_AssemblyVersion>}%')
delete from [SVSERVICE] where type = 'createmhtfile'
go

if not exists(select assemblyname from svservice where type = 'createmhtfile')
INSERT INTO [SVSERVICE] ([Type],[AssemblyName],[ClassName],[Status],[StartDate],[Xml]) VALUES ('createmhtfile', 'ShareVis, Version={<WinshuttleWorkflow_AssemblyVersion>}, Culture=neutral, PublicKeyToken=404db1d4cac98e68', 'ShareVis.Service.CreateMhtFileExecutor', 1, '3/5/2006 9:53:39 AM', '<?xml version="1.0" encoding="utf-16"?><CreateMhtFileExecutor xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"></CreateMhtFileExecutor>')
go

CREATE TABLE [dbo].[SVPREUPLOAD] (
	[Context] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[FileUrl] [nvarchar] (500) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Xml] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[CreatedDate] [datetime] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

/*
Table to Store All the Server Configurations i.e.
1. Plugin Configuration
2. Global Configuration
3. Participant Resolver Configuration
4. Infopath Control Configuration
*/
set quoted_identifier off;
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFServerConfiguration]') AND type in (N'U'))
Begin
CREATE TABLE [dbo].[WFServerConfiguration](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Guid] [nvarchar](40) NOT NULL,
	[Name] [nvarchar](128) NOT NULL,
	[MetaData] [xml] NOT NULL,
	[Status] [int] NOT NULL,
	[Type] [int] NOT NULL default(0),
	[TimeStamp] [timestamp] NOT NULL
) ON [PRIMARY]
End
GO

/*
Table to Store All the Configuration Types
*/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFTypeLookup]') AND type in (N'U'))
Begin
CREATE TABLE [dbo].[WFTypeLookup](
	[Id] [int] NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[ValidateSchema] [xml] NOT NULL,
	[Xslt] [xml] NULL,
 CONSTRAINT [PK_WFTypeLookup] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
End
GO

/*
This Procedure Inserts/Updates the WFServerConfiguration Table
*/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_InsertUpdateServerConfiguration]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_InsertUpdateServerConfiguration]

GO
CREATE Procedure [dbo].[sp_InsertUpdateServerConfiguration]
(
	  @Id int = 0,
      @Guid NVarchar(40),
      @Name nvarchar(128),
      @MetaData XML,
      @Status int =0,
      @Type int
)

as
BEGIN
Declare @count INT
SET @count = 0
      
	If @Id <= 0
		Begin
			Select @count = COUNT(1) From WFServerConfiguration
			WHERE Name =@Name And Guid = @Guid
		END
		Else
		Begin
			Select @count=COUNT(1) From WFServerConfiguration 
			WHERE Id = @Id
		End
    If @count = 0     
		Begin           
			Insert Into WFServerConfiguration(Guid,Name,MetaData, Status, Type)
				   values(@Guid,@Name,@MetaData, @Status, @Type)
		End
    Else
      Begin
      If @Id <= 0
			Begin
				Update WFServerConfiguration 
				Set MetaData = @MetaData,
				Status = @Status,
				Type = @Type
				Where Name =@Name And Guid = @Guid				
			End
	  Else
			Begin
				Update WFServerConfiguration 
				Set Name = @Name,
				MetaData = @MetaData,
				Status = @Status,
				Type = @Type
				Where  Id = @Id
			END
	  End
END
GO

/*
This Procedure Deletes From WFServerConfiguration Table
*/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_DeleteServerConfiguration]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_DeleteServerConfiguration]

 GO
Create Procedure [dbo].[sp_DeleteServerConfiguration]
(
	 @Id int
)

as
BEGIN
	Delete From WFServerConfiguration where [ID] = @Id
 END
GO

/*
This Procedure Selects From WFServerConfigurationTable.
*/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_GetAllServerConfiguration]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_GetAllServerConfiguration]

 GO
CREATE Procedure [dbo].[sp_GetAllServerConfiguration]
(
      @Guid NVarchar(40),
      @Type int,
      @Status int = -1
)
as
BEGIN
	if(@Status = -1)
		Begin
			Select * From WFServerConfiguration
			Where Guid = @Guid And Type = @Type
		End
	Else
		Begin
		SELECT * From WFServerConfiguration 
		WHERE Guid = @Guid And Status = @Status And Type = @Type
    End
END
GO

/*
This Procedure Selects From WFServerConfigurationTable.
*/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_GetServerConfiguration]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_GetServerConfiguration]

 GO
CREATE Procedure [dbo].[sp_GetServerConfiguration]
(
      @Guid NVarchar(40),
      @Type int,
      @Name nvarchar(128)
)
as
BEGIN
	Begin
		SELECT * From WFServerConfiguration 
		WHERE Guid = @Guid And Lower(Name) = Lower(@Name) And Type = @Type
    End
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_GetServerConfigurationXML]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_GetServerConfigurationXML]

 GO
CREATE Procedure [dbo].[sp_GetServerConfigurationXML]
(
      @Guid NVarchar(40),
      @Type int,
      @Name nvarchar(128)
)
as
BEGIN
	Begin
		SELECT MetaData From WFServerConfiguration 
		WHERE Guid = @Guid And Name = @Name And Type = @Type
    End
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_GetServerConfigurationXMLForId]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_GetServerConfigurationXMLForId]

 GO
CREATE Procedure [dbo].[sp_GetServerConfigurationXMLForId]
(
      @Guid NVarchar(40),
      @Type int,
      @Id int
)
as
BEGIN
	Begin
		SELECT MetaData From WFServerConfiguration 
		WHERE Guid = @Guid And ID = @Id And Type = @Type
    End
END
GO

/*
This Procedure Fetches all the configuration types
*/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_GetConfigurationTypes]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_GetConfigurationTypes]

 GO
Create Procedure [dbo].[sp_GetConfigurationTypes]

as
BEGIN
	Select * From WFTypeLookup
 END
GO

Insert into WFTypeLookup(Id,Name, ValidateSchema)
values(1,'Plugin','<?xml version="1.0"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
<xs:element name="Plugin">
<xs:complexType>
<xs:sequence>
<xs:element name="Parameters" minOccurs="0" maxOccurs="1">
<xs:complexType>
<xs:sequence>
<xs:element name="Parameter" minOccurs="0" maxOccurs="unbounded">
<xs:complexType>
<xs:sequence>
<xs:element name="Validators" minOccurs="0" maxOccurs="1">
<xs:complexType>
<xs:sequence>
<xs:element name="Validator" minOccurs="0" maxOccurs="unbounded">
<xs:complexType>
<xs:attribute name="Message" type="xs:string" />
<xs:attribute name="RegularExpression" type="xs:string" />
</xs:complexType>
</xs:element>
</xs:sequence>
</xs:complexType>
</xs:element>
</xs:sequence>
<xs:attribute name="Occurence" type="xs:string" use="required" />
<xs:attribute name="Description" type="xs:string" use="required" />
<xs:attribute name="Datatype" type="xs:string" use="required" />
<xs:attribute name="Value" type="xs:string" />
<xs:attribute name="Name" type="xs:string" />
<xs:attribute name="ListOfValues" type="xs:string" />
<xs:attribute name="EditableName" type="xs:string" />
<xs:attribute name="Required" type="xs:string" />
</xs:complexType>
</xs:element>
</xs:sequence>
</xs:complexType>
</xs:element>
</xs:sequence>
<xs:attribute name="Name" type="xs:string" use="required" />
<xs:attribute name="Assembly" type="xs:string" use="required" />
<xs:attribute name="Class" type="xs:string" use="required" />
<xs:attribute name="ValidatorClass" type="xs:string" />
<xs:attribute name="Description" type="xs:string" use="required" />
<xs:attribute name="ParmNames" type="xs:string" use="required" />
<xs:attribute name="ValidatorArguments" type="xs:string" />
<xs:attribute name="Variants" type="xs:string" />
<xs:attribute name="ASyncAllowed" type="xs:string" />
</xs:complexType>
</xs:element>
</xs:schema>')
go
Insert into WFTypeLookup(Id,Name, ValidateSchema)
values(2,'Global Configuration','<?xml version="1.0"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
<xs:element name="add">
<xs:complexType>
<xs:simpleContent>
<xs:extension base="xs:string">
<xs:attribute name="key" type="xs:string" use="required"/>
<xs:attribute name="value" type="xs:string"  use="required" />
</xs:extension>
</xs:simpleContent>
</xs:complexType>
</xs:element>
</xs:schema>')
go
Insert into WFTypeLookup(Id,Name, ValidateSchema)
values(3,'Participant Resolver','<?xml version="1.0"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
<xs:element name="ParticipantResolver">
<xs:complexType>
<xs:simpleContent>
<xs:extension base="xs:string">
<xs:attribute name="Name" type="xs:string" use="required"/>
<xs:attribute name="ParmNames" type="xs:string"  use="required" />
<xs:attribute name="Variants" type="xs:string" />
</xs:extension>
</xs:simpleContent>
</xs:complexType>
</xs:element>
</xs:schema>')
go
Insert into WFTypeLookup(Id,Name, ValidateSchema)
values(4,'InfoPath Control','<?xml version="1.0"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
<xs:element name="Control">
<xs:complexType>
<xs:simpleContent>
<xs:extension base="xs:string">
<xs:attribute name="Name" type="xs:string" use="required"/>
<xs:attribute name="ClsId" type="xs:string"  use="required" />
<xs:attribute name="Variants" type="xs:string" use="required" />
</xs:extension>
</xs:simpleContent>
</xs:complexType>
</xs:element>
</xs:schema>')
go

/** Global Configuration keys table**/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFGlobalConfig]') AND type in (N'U'))
BEGIN
	CREATE TABLE [dbo].[WFGlobalConfig](
		  [Id] [int] IDENTITY(1,1) NOT NULL,
		  [Guid] [nvarchar](40) NOT NULL,
		  [Name] [nvarchar](128) NOT NULL,
		  [Value] [nvarchar](max) NOT NULL,
		  [TimeStamp] [timestamp] NOT NULL
	) ON [PRIMARY]
END
GO

/** Stored Procedures for WFGlobalConfig**/

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_InsertUpdateGlobalConfig]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_InsertUpdateGlobalConfig]

 GO

Create Procedure [dbo].[ws_InsertUpdateGlobalConfig]
(
	  @Id int = 0,
      @Name NVarchar(128),
      @Value NVarchar(max),
      @Guid NVarchar(40)='00000000-0000-0000-0000-000000000000'
)

as
Begin
Declare @count INT
SET @count = 0

If @Id <= 0
Begin
	Select @count=COUNT(1) From WFGlobalConfig 
	WHERE Name =@Name And Guid = @Guid
End
Else
Begin
	Select @count=COUNT(1) From WFGlobalConfig 
	WHERE Id=@Id
END


If @count = 0
      Begin
		Insert Into WFGlobalConfig(Guid,Name,Value)
                        Values(
                                 @Guid,
                                 @Name,
                                 @Value
                                 )
      End
Else
      Begin
      If @Id <= 0
			Begin
				Update WFGlobalConfig
                 Set Value=@Value
                 Where Name =@Name And Guid = @Guid
			End
	  Else
			Begin
				 Update WFGlobalConfig
                 Set Value=@value
                 Where Id=@Id
			END
          
      End
 END     
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetGlobalKey]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetGlobalKey]

 Go
CREATE Procedure [dbo].[ws_GetGlobalKey]
(
	  @Guid NVarchar(40),
      @Name NVarchar(128)
)
as
BEGIN
    SELECT Value From WFGlobalConfig
    WHERE Lower(Name) = Lower(@Name) And Guid = @Guid
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_DeleteGlobalConfig]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_DeleteGlobalConfig]

 GO

Create Procedure [dbo].[ws_DeleteGlobalConfig]
(
      @Id int /*,
       @Name nvarchar(128)*/
)

as
BEGIN
	Delete From WFGlobalConfig 
	WHERE Id = @Id /* Lower(Name) = Lower(@Name)*/
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_DeleteGlobalConfigByName]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_DeleteGlobalConfigByName]

 GO

Create Procedure [dbo].[ws_DeleteGlobalConfigByName]
(
       @Name nvarchar(128),
       @Guid NVarchar(40)
)

as
BEGIN
	Delete From WFGlobalConfig 
	WHERE Lower(Name) = Lower(@Name) And Guid = @Guid
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetAllGlobalConfiguration]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetAllGlobalConfiguration]

 GO
CREATE Procedure [dbo].[ws_GetAllGlobalConfiguration]
(
      @Guid NVarchar(40)
)
as
BEGIN
	Begin
		SELECT Name,Value From WFGlobalConfig
		WHERE Guid = @Guid
    End
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_UpdateScheduledJob]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_UpdateScheduledJob]
GO

CREATE Procedure [dbo].[ws_UpdateScheduledJob]
(
	  @id bigint,
      @Status int,
	  @StartDate datetime,
	  @Xml ntext,
	  @version bigint,
	  @retvalue int OUTPUT
)
as
BEGIN
	BEGIN
	Declare @CurrentStatus int
	Declare @CurrentVersion bigint
	Select @CurrentStatus = Status, @CurrentVersion = Cast(TimeStamp as BIGINT) from SVService where ID = @id
	if(@CurrentStatus <> 1)
		BEGIN
			Set @retvalue = 2
		END
	ELSE
		BEGIN
			if(@CurrentVersion <> @version)
				BEGIN
					Set @retvalue = 1
				END
			ELSE
				BEGIN
					Update SVService Set Status = @Status, StartDate = @StartDate, Xml = @Xml where ID = @id
					Set @retvalue = 0
				END
		END	
    End
END
GO

SET QUOTED_IDENTIFIER ON
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_FillWfGlobalConfigFromXml]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_FillWfGlobalConfigFromXml]

 GO
CREATE Procedure [dbo].[ws_FillWfGlobalConfigFromXml]
(
      @Guid NVarchar(40),
      @XmlQuery AS XML
)
as
BEGIN
		Delete From WFGlobalConfig WHERE Guid = @Guid;
		
		Insert Into WFGlobalConfig(Guid, Name, Value)
		SELECT @Guid, config.value('(@key)', 'NVARCHAR(max)') as configKey, config.value('(@value)', 'NVARCHAR(max)') as configValue
		FROM @XmlQuery.nodes('/configuration/appSettings/add') AS XmlQuery(config)
		/*where config.value('(@key)', 'VARCHAR(200)') not in (select Name from WFGlobalConfig)*/

END
GO


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sp_GetPluginsForDesigner]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sp_GetPluginsForDesigner]

 GO
CREATE Procedure [dbo].[sp_GetPluginsForDesigner]
(
      @Guid NVarchar(40)
)
as
BEGIN
	Begin
		SELECT P.ID.value('@Name','nvarchar(128)') as Name,
                     P.ID.value('@Assembly','nvarchar(128)') as Assembly,
                     P.ID.value('@Class','nvarchar(128)') as Class,
                     isnull(P.ID.value('@ParmNames','nvarchar(256)'),'') as ParmNames,
                     isnull(P.ID.value('@ValidatorClass','nvarchar(128)'),'') as ValidatorClass,
                     isnull(P.ID.value('@ValidatorArguments','nvarchar(2560)'),'') as ValidatorArguments,
                     isnull(P.ID.value('@Variants','nvarchar(2560)'),'') as Variants,
                     isnull(P.ID.value('@Description','nvarchar(max)'),'') as Description,
                     isnull(P.ID.value('@HelpLink','nvarchar(max)'),'') as HelpLink,
                     isnull(P.ID.query('Parameters'),'') as ParameterXML               
            From WFServerConfiguration 
                   Cross Apply MetaData.nodes('Plugin') as P(ID)
            Where Guid = @Guid And Type = 1
            ORDER BY Name ASC
    End
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetPRsForDesigner]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetPRsForDesigner]

 GO
CREATE Procedure [dbo].[ws_GetPRsForDesigner]
(
      @Guid NVarchar(40)
)
as
BEGIN
	Begin
		SELECT P.ID.value('@Name','nvarchar(128)') as Name,
			   isnull(P.ID.value('@ParmNames','nvarchar(2560)'),'') as ParmNames,
			   isnull(P.ID.value('@Variants','nvarchar(2560)'),'') as Variants
		From WFServerConfiguration 
			 Cross Apply MetaData.nodes('ParticipantResolver') as P(ID)
		Where Guid = @Guid And Type = 3
    End
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetFormControlsForDesigner]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetFormControlsForDesigner]

 GO
CREATE Procedure [dbo].[ws_GetFormControlsForDesigner]
(
      @Guid NVarchar(40)
)
as
BEGIN
	Begin
		SELECT P.ID.value('@Name','nvarchar(128)') as Name,
                     isnull(P.ID.value('@ClsId','nvarchar(40)'),'') as ClsId,
                     isnull(P.ID.value('@Variants','nvarchar(256)'),'') as Variants               
            From WFServerConfiguration 
                   Cross Apply MetaData.nodes('Control') as P(ID)
            Where Guid = @Guid And Type = 4
    End
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_FillWfPluginFromXML]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_FillWfPluginFromXML]
GO
CREATE Procedure [dbo].[ws_FillWfPluginFromXML]
(
      @Guid NVarchar(40)= '00000000-0000-0000-0000-000000000000',
      @XmlQuery AS XML
)
as
BEGIN
		Delete from WFServerConfiguration Where Guid = @Guid And Type = 1;
		Insert Into WFServerConfiguration(Guid,Name,MetaData,Status,Type)
		SELECT @Guid, Plugin.value('(@Name)', 'VARCHAR(128)') as plugin_name, Plugin.query('.'), 1, 1
		FROM @XmlQuery.nodes('/PluginRegistry/Plugin') AS XmlQuery(Plugin)
		/*where Plugin.value('(@Name)', 'VARCHAR(200)') not in (select PlugInName from WFPlugIn) */

END

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_FillWfParticipantResolverFromXml]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_FillWfParticipantResolverFromXml]

 GO
 
CREATE Procedure [dbo].[ws_FillWfParticipantResolverFromXml]
(
      @Guid NVarchar(40)='00000000-0000-0000-0000-000000000000',
      @XmlQuery AS XML
)
as
BEGIN
	Delete from WFServerConfiguration Where Guid = @Guid And Type = 3;
	Insert Into WFServerConfiguration(Guid,Name,MetaData,Status,Type)
	SELECT @Guid, ParticipantResolver.value('(@Name)', 'VARCHAR(128)') as ParticipantResolver_name, ParticipantResolver.query('.'),1, 3
	FROM @XmlQuery.nodes('/ParticipantResolverList/ParticipantResolver') AS XmlQuery(ParticipantResolver)
	/*where ParticipantResolver.value('(@Name)', 'VARCHAR(200)') not in (select name from WFParticipantResolver)*/

END

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_FillFormControlsFromXml]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_FillFormControlsFromXml]

 GO
 
CREATE Procedure [dbo].[ws_FillFormControlsFromXml]
(
      @Guid NVarchar(40)='00000000-0000-0000-0000-000000000000',
      @XmlQuery AS XML
)
as
BEGIN
	Delete from WFServerConfiguration Where Guid = @Guid And Type = 4;
	Insert Into WFServerConfiguration(Guid,Name,MetaData,Status,Type)
	SELECT @Guid, FormControl.value('(@Name)', 'VARCHAR(128)') as FormControl_name, FormControl.query('.'),1, 4
	FROM @XmlQuery.nodes('/FormControls/Control') AS XmlQuery(FormControl)
	/*where ParticipantResolver.value('(@Name)', 'VARCHAR(200)') not in (select name from WFParticipantResolver)*/

END

GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFLicense]') AND type in (N'U'))
BEGIN

CREATE TABLE [dbo].[WFLicense](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[HostName] [nvarchar](512) NOT NULL,
	[Key] [nvarchar](2560) NOT NULL,
	[LastModified] [DateTime] default (Getdate()) NOT NULL
) ON [PRIMARY]

END

GO


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_InsertLicense]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_InsertLicense]

GO

CREATE PROCEDURE [dbo].[ws_InsertLicense] 
	(    
	     @hostname Nvarchar(512),
		 @key NVarchar(2560) 
	) 
 AS 
 BEGIN 
	 
	 Declare @ID INT;
	 Set @ID = -1;
	 Select Top(1) @ID = Id from  WFLicense Where HostName=@hostname;
	 If @ID <> -1
		Begin
			Update WFLicense
				Set [Key] = @key, LastModified = GETDATE()
				Where Id = @ID and HostName = @hostname;
		End
	Else
		Begin
			Insert into WFLicense(hostname,[key])
			Values(@hostname,@key)  
		End
 END
 
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetLicense]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetLicense]

GO

CREATE PROCEDURE [dbo].[ws_GetLicense]
AS
BEGIN
	Select * from WFLicense

END

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetLicenseOnHostName]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetLicenseOnHostName]

GO


Create Procedure [dbo].[ws_GetLicenseOnHostName]
(
	@hostname NVarchar(512)
)
as

Begin
	Select * from WFLicense Where HostName=@hostname 
End

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_DeleteLicenseOnHostName]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_DeleteLicenseOnHostName]

GO


Create Procedure [dbo].[ws_DeleteLicenseOnHostName]
(
	@hostname NVarchar(512)
)
as

Begin
	Delete from WFLicense Where HostName=@hostname 
End

GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFSchedulerHistory]') AND type in (N'U'))
BEGIN

CREATE TABLE [dbo].[WFSchedulerHistory](
	[Id] [bigint] IDENTITY(1,1) NOT NULL,
	[Job][nvarchar](128) NOT NULL,
	[StartDate] [datetime] NOT NULL,
	[CompletedDate] [datetime] NOT NULL,
	[Result] [nvarchar](50) NOT NULL,
	[Comments] [nvarchar](2048) NOT NULL,
	[TimeStamp] [timestamp] NOT NULL,
	[WebAppGuid] [uniqueidentifier] NOT NULL,
	[SvServiceId] [bigint] NOT NULL  
) ON [PRIMARY]

END

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetSchedulerHistorySearch]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetSchedulerHistorySearch]

GO

Create Procedure [dbo].[ws_GetSchedulerHistorySearch]
(
	@JobType NVarchar(128),
	@Result NVarchar(50),
	@SortBy NVarchar(50)='CompletedDate',
	@SortOrder NVarchar(50)='DESC'
)
AS

Begin
Declare @whereClause NVarchar(1000);
Declare @query NVarchar(1500);	
	If(LTRIM(RTRIM(@SortBy)) = '')
		Begin
			Set @SortBy = 'CompletedDate';
		End
		
	If(LTRIM(RTRIM(@SortOrder)) = '')
		Begin
			Set @SortOrder = 'DESC';
		End
	If(@SortOrder='Ascending' OR @SortOrder='ascending')
	BEGIN
	Set @SortOrder='ASC';
	END
	ELSE IF(@SortOrder='Descending' OR @SortOrder='descending')
	BEGIN
	Set @SortOrder='DESC'
	END
	IF(@JobType='ALL' AND @Result='ALL')
	BEGIN
	Set @whereClause = '';
	END
	ELSE IF(@JobType='ALL' AND @Result<>'ALL')
	BEGIN
	Set @whereClause = ' Where Result = ''' + @Result + '''';
	END
	ELSE IF(@JobType<>'ALL' AND @Result='ALL')
	BEGIN
	Set @whereClause = ' Where Job =''' +@JobType + '''';
	END	
	ELSE IF(@JobType<>'ALL' AND @Result<>'ALL')
	BEGIN
	Set @whereClause = ' Where Job =''' +@JobType +''' ANd Result ='''+ @Result + '''';	
	END
	Set @query = 'Select [Id]
		  ,Case  
				When [Job] = ''PurgeBackgroundJobs'' then ''Purge Background Jobs'' 
				When [Job] = ''PurgeProcessData'' then ''Purge Process Data''
				When [Job] = ''MarkInactiveProcesses'' then ''Mark Inactive Processes''
				When [Job] = ''ArchiveObsoleteSolution'' then ''Archive Obsolete Workflow Solution''
			End As [Job]
			,CONVERT(varchar, [StartDate], 101) + '' '' +
       SUBSTRING(CONVERT(VARCHAR(19), [StartDate], 100),13,7) as [StartDate]
		  ,CONVERT(varchar, [CompletedDate], 101) + '' '' +
       SUBSTRING(CONVERT(VARCHAR(19), [CompletedDate], 100),13,7) as [EndDate]
		  ,[Result]
		  ,[Comments]
		  ,RIGHT(''0'' + CAST(DATEDIFF(HOUR,StartDate,completeddate) AS VARCHAR),2) 
		  + '':'' + RIGHT(''0'' + CAST(DATEDIFF(MINUTE,StartDate,completeddate) AS VARCHAR), 2) 
		  + '':'' + RIGHT(''0'' + CAST(DATEDIFF(SECOND,StartDate,completeddate) AS VARCHAR),2) AS [Duration]
		  ,[WebAppGuid]
		From 
			WFSchedulerHistory ' + @whereClause + ' Order By ' + @SortBy + ' ' + @SortOrder;
Execute sp_Executesql @query
End

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_AddSchedulerHistory]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_AddSchedulerHistory]

GO


Create Procedure [dbo].[ws_AddSchedulerHistory]
(
	@JobType NVarchar(128),
	@StartDate datetime,
	@CompletedDate datetime,
	@Result NVarchar(50),
	@Comments NVarchar(2048),
	@WebAppGuid Uniqueidentifier,
	@SvServiceId bigint 
)
AS

Begin
	 INSERT INTO [WFSchedulerHistory]
           ([Job]
           ,[StartDate]
           ,[CompletedDate]
           ,[Result]
           ,[Comments]
           ,[WebAppGuid]
           ,[SvServiceId])
     VALUES
           (
			@JobType
           ,@StartDate
           ,@CompletedDate
           ,@Result
           ,@Comments
           ,@WebAppGuid
           ,@SvServiceId)
End

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_DeleteSchedulerHistory]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_DeleteSchedulerHistory]

GO


Create Procedure [dbo].[ws_DeleteSchedulerHistory]
(
	@CompletedDate datetime
)
AS

Begin	
	 DELETE [WFSchedulerHistory] WHERE CompletedDate < @CompletedDate
End

GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetScheduledJobs]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetScheduledJobs]

GO

CREATE Procedure [dbo].[ws_GetScheduledJobs]
(
	@SortBy NVarchar(50)='StartDate',
	@SortOrder NVarchar(50)='ASC'
)
AS  
Begin
Declare @query NVarchar(1000);
If(LTRIM(RTRIM(@SortBy)) = '')
		Begin
			Set @SortBy = 'StartDate';
		End
		
	If(LTRIM(RTRIM(@SortOrder)) = '')
		Begin
			Set @SortOrder = 'ASC';
		End
	If(@SortOrder='Ascending' OR @SortOrder='ascending')
	BEGIN
	Set @SortOrder='ASC';
	END
	ELSE IF(@SortOrder='Descending' OR @SortOrder='descending')
	BEGIN
	Set @SortOrder='DESC'
	END
	If(@SortBy='Schedule')
	BEGIN
	Set @SortBy='StartDate'
	END
Set @query =' Select [ID] , 
	Case  
		When [Type] = ''PurgeBackgroundJobs'' then ''Purge Background Jobs''
		When [Type] = ''PurgeProcessData'' then ''Purge Process Data''
		When [Type] = ''MarkInactiveProcesses'' then ''Mark Inactive Processes''
		When [Type] = ''ArchiveObsoleteSolution'' then ''Archive Obsolete Workflow Solution''
	End AS [Type], 	
	[Xml], SUBSTRING(CONVERT(VARCHAR(19), [StartDate], 100),13,7) as StartTime,CONVERT(varchar, [ProcessingDate], 101) + '' '' +
       SUBSTRING(CONVERT(VARCHAR(19), [ProcessingDate], 100),13,7) as ProcessingDate from SVSERVICE where Status=1 and Type IN (''PurgeBackgroundJobs'', ''PurgeProcessData'', ''MarkInactiveProcesses'', ''ArchiveObsoleteSolution'') Order By ' + @SortBy + ' ' + @SortOrder;
Execute sp_Executesql @query;
End
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetStaleProcessDefinitions]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetStaleProcessDefinitions]

Go
CREATE Procedure [dbo].[ws_GetStaleProcessDefinitions]
(
        @WebGuid nvarchar(100)
)
as
BEGIN
     SELECT distinct(ID) FROM WFPROCDEF 
	 WHERE Status = 2 and Context = @WebGuid
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetExistingProcessCount]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetExistingProcessCount]

Go
CREATE Procedure [dbo].[ws_GetExistingProcessCount]
(
      @ProcessDefinitionID bigint 
)
as
BEGIN
     SELECT count(1) from WFPROCESS 
     WHERE DefId = @ProcessDefinitionID 
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_GetSolution]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_GetSolution]

Go
CREATE Procedure [dbo].[ws_GetSolution]
(
      @ProcessDefinitionID bigint 
)
as
BEGIN
    SELECT Name, FileContent FROM WSSLN 
    WHERE ProcessDefinitionID = @ProcessDefinitionID 
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ws_DeleteProcessDefinitionData]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ws_DeleteProcessDefinitionData]

Go

CREATE Procedure [dbo].[ws_DeleteProcessDefinitionData]
(
      @ProcessDefinitionID bigint 
)
as
BEGIN
     DELETE from WFACTDEF 
     WHERE PROCID = @ProcessDefinitionID
     
     DELETE from WFATTRIBUTEDEF
     WHERE ProcID = @ProcessDefinitionID
     
     DELETE from WFPERFORMERDEF
     WHERE ProcDefID = @ProcessDefinitionID
     
     DELETE from WFTRANSDEF 
     WHERE PROCID = @ProcessDefinitionID
     
     DELETE from WFPROCDEF 
     WHERE ID = @ProcessDefinitionID
	 
	 DELETE from WSSLN
	 WHERE ProcessDefinitionID = @ProcessDefinitionID
END

GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[WFLogging]') AND type in (N'U'))
BEGIN
	CREATE TABLE [WFLogging](
	[GUID][nvarchar](40) NOT NULL,
	[Core]  [bit] NOT NULL,
	[Timer] [bit] NOT NULL,
	[SVService] [bit] NOT NULL,
	[SVAdm] [bit] NOT NULL,
	[CA]  [bit] NOT NULL,
	[LoggingLevel] [nvarchar](8) NOT NULL,
	[LogRetention] [bit] NOT NULL,
	[StackTrace] [bit] NOT NULL,
	[AsyncLogging] [bit] NOT NULL,
	[LoggingClasses] [nvarchar](max)NULL
	) ON [PRIMARY]
END
GO


GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_InsertOrUpdateLogging]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_InsertOrUpdateLogging]
GO
CREATE PROCEDURE ws_InsertOrUpdateLogging
	(@Guid nvarchar(40),
	@Core bit,
	@Timer bit,
	@SVService bit,
	@SVAdm bit,
	@CA bit,
	@LoggingLevel nvarchar(8),
	@LogRetention bit,
	@StackTrace bit,
	@AsyncLogging bit,
	@LoggingClasses nvarchar(max))
AS
BEGIN
	IF EXISTS (SELECT 1 From  [WFLogging] WHERE [GUID]=@Guid) 
	BEGIN 
		UPDATE [WFLogging] SET [Core]=@Core,[Timer]=@Timer, [SVService]=@SVService,[SVAdm]=@SVAdm,[CA]=@CA,[LoggingLevel]=@LoggingLevel,
							[LogRetention]=@LogRetention,[StackTrace]=@StackTrace,[AsyncLogging]=@AsyncLogging,[LoggingClasses]=@LoggingClasses
		WHERE [GUID]=@Guid
	END 
	ELSE 
	BEGIN 
	INSERT INTO [WFLogging]
			   ([GUID]
			   ,[Core]
			   ,[Timer]
			   ,[SVService]
			   ,[SVAdm]
			   ,[CA]
			   ,[LoggingLevel]
			   ,[LogRetention]
			   ,[StackTrace]
			   ,[AsyncLogging]
			   ,[LoggingClasses])
		 VALUES
			   (@Guid,
				@Core,
				@Timer,
				@SVService,
				@SVAdm,
				@CA,
				@LoggingLevel,
				@LogRetention,
				@StackTrace,
				@AsyncLogging,
				@LoggingClasses)
	END
END
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetLogging]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetLogging]
GO
CREATE PROCEDURE ws_GetLogging
	(@Guid nvarchar(40))
AS
BEGIN
	SELECT[Core],[Timer],[SVService],[SVAdm],[CA],[LoggingLevel],[LogRetention],[StackTrace],[AsyncLogging],[LoggingClasses] FROM [WFLogging] WHERE GUID=@Guid
END
GO





IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[sp_GetAllServerConfigNameDataAndCount]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [sp_GetAllServerConfigNameDataAndCount]
GO
Create Procedure [dbo].[sp_GetAllServerConfigNameDataAndCount]
(
	@Guid Varchar(40),
	@Status INT 
)
as

Select Type, Name from WFServerConfiguration Where Guid = @Guid and Status = @Status Order By Type, Name;

GO

/*
Table to Store all the DB Tables with categories
*/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFTablesCategory]') AND type in (N'U'))
Begin
CREATE TABLE [dbo].[WFTablesCategory](
	[Id] [int] NOT NULL Identity(1,1),
	[TableName]sysname NOT NULL,
	[Category] [int] NOT NULL Default(1),
	[Description] [nvarchar](max),
CONSTRAINT [PK_WFTablesCategory] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
End
GO

/*
Table to Store all the Categories of WF DB Tables
*/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[WFTablesCategoryLookup]') AND type in (N'U'))
Begin
CREATE TABLE [dbo].[WFTablesCategoryLookup](
	[Id] [int] NOT NULL,
	[Category] [nvarchar](56) NOT NULL,
CONSTRAINT [PK_WFTablesCategoryLookup] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
End
GO



If Not Exists(select * from [WFTablesCategoryLookup] where Category = 'Solution')
INSERT INTO [WFTablesCategoryLookup](Id, Category)
VALUES(1, 'Solution')
GO

If Not Exists(select * from [WFTablesCategoryLookup] where Category = 'Transaction')
INSERT INTO [WFTablesCategoryLookup](Id, Category)
VALUES(2, 'Transaction')
GO

If Not Exists(select * from [WFTablesCategoryLookup] where Category = 'Configuration')
INSERT INTO [WFTablesCategoryLookup](Id, Category)
VALUES(3, 'Configuration')
GO


If Not Exists(select * from [WFTablesCategory] where TableName = 'WFACTDEF')
Insert Into WFTablesCategory(TableName, [Description],Category)  Values('WFACTDEF','This table keeps a track of all activities in workflow process. Example if the workflow process is having Start, Activity and End node. This table consists of 3 rows which is one for activity.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WSSLN')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WSSLN','This table stores information corresponding to each solution published on workflow sites. This is populated at publish time.', 1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVPREUPLOAD')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVPREUPLOAD','This will keep a track of uploaded documents from upload page through explorer web part. There will create one record for each uploaded document from upload page.', 2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFACTIVITYTYPE')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFACTIVITYTYPE','Master values of activity type.',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFASSIGNMENT')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFASSIGNMENT','This tables maintains all the records of running process and completed process. This will create row for each step in the workflow.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFASSIGNMENTSTATUS')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFASSIGNMENTSTATUS','Master values of assignment status',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFATTRIBUTE')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFATTRIBUTE','These are the rows specified in the extended attributes of the workflow process. This table will populated at run time of the process',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFATTRIBUTEDEF')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFATTRIBUTEDEF','Extended attributes of the workflow process created during workflow publish.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFMANAGEDATTR')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFMANAGEDATTR','This table is used to persist the managed attributes of approval activity.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFPERFORMER')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFPERFORMER','This table contains data corresponding to users who have been assigned any of the swimlanes of workflow. This table is populated at runtime and not during publish time.',2);	
GO

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFPERFORMERDEF')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFPERFORMERDEF','This table contains information about swimlanes present in a workflow while publishing. This is populated at publish time and not runtime.',1);	
GO

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFPROCDEF')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFPROCDEF','This table stores information about published workflow properties. It is populated at workflow publishing time and not runtime.',1);	
GO

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFPROCESS')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFPROCESS','This table contains information about each instance of workflow on Winshuttle Workflow Site. This is populated at runtime.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFPROCESSSTATUS')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFPROCESSSTATUS','Purpose of this table is to act as reference to column STATUS of table WFPROCESS.',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFTRANSDEF')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFTRANSDEF','This table stores information about all the transitions (the arrows between nodes of workflow) of published workflow process. This is populated at publish time and not at runtime.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVSERVICE')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVSERVICE','This table keeps a track of the workflow tasks in the back end. This will be used by svservice to run the scheduled tasks.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVConfig')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVConfig','This Store SVConfigurator Keys. Must be site level or lower for information to be stored in DB.',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVSPListItem')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVSPListItem','This table is used to cache the Form Library web part data. This will save entries when dynamic refresh is ON.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFDELEGATION')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFDELEGATION','Out of office delegations created by users to assign tasks on behalf.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFACTORGROUP')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFACTORGROUP','This will create records when labeled assignments are created from workflow designer.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVItemProperty')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVItemProperty','This table keeps a track of the SharePoint file versions when Approved|Reverted in Docex site.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVNAMEGEN')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVNAMEGEN','This table is stores all the TableName templates created in the workflow.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVExternalEvent')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVExternalEvent','This table is used to save the auto-post document details. For each file posted there will one entry in this table.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVEvent')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVEvent','This tables logs a record whenever 1. Any document is routed and EgdeServer configuration is specified in sharevis.config file.2. If Form data exchange is control is used to send the value back from child to parent form.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WSServiceCaching')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WSServiceCaching','This table is used to handle Caching of WSDL in running webservices.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WSDLFiles')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WSDLFiles','This table stores information corresponding to any Third Party Webservice used in solution.',1);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'SVSERVICESANITY')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('SVSERVICESANITY','This table is used to prevent duplicate posting in case of Winshuttle AutoPost Plugin.',2);	
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFTypeLookup')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFTypeLookup','This Table to Store All the Configuration Types	,e.g. plugin, global configuration',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFGlobalConfig')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFGlobalConfig','This table to Store Global level SVConfigurator Keys.',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFLicense')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFLicense','This table to store WF License key with corresponding hostname.',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFServerConfiguration')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFServerConfiguration','This Table to Store All the Server Configurations-1.Plugin Configuration,2. Global Configuration,3. Participant Resolver Configuration,4. Infopath Control Configuration',3);
GO

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFTablesCategory')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFTablesCategory',' This Table to Store all the DB Tables with categories.',3);
Go

If Not Exists(select * from [WFTablesCategory] where TableName = 'WFTablesCategoryLookup')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFTablesCategoryLookup','This Table to Store all the Categories of WF DB Tables like Solution, Transaction and Configuration',3);
GO

If Not Exists(select * from [WFTablesCategory] where TableName = 'WSFieldPack')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WSFieldPack','This table is used to store field pack definitions',1);
GO

If Not Exists(select * from [WFTablesCategory] where TableName = 'WSFieldPackRef')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WSFieldPackRef','This table is used to store field pack form usage/reference information',1);
GO
If Not Exists(select * from [WFTablesCategory] where TableName = 'WFLogging')
Insert Into WFTablesCategory(TableName, [Description],Category) Values('WFLogging','This table is used to store the workflow logging configuration information',3);
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetDataUsageforTables]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetDataUsageforTables]
GO
CREATE PROCEDURE [dbo].[ws_GetDataUsageforTables]
AS
CREATE TABLE #temp(
tableName sysname, rows_count int, reserved_size varchar(50), data_size varchar(50), index_size varchar(50), unused_size varchar(50)
)
INSERT INTO #temp
EXEC  sp_msforeachtable  'sp_spaceused [?]' 

SELECT t.tableName ,t.data_size , t.rows_count,TCL.Category FROM #temp t Join WFTablesCategory TC
		ON  t.tableName=TC.TableName
		JOIN WFTablesCategoryLookup TCL ON TC.Category= TCL.Id

GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetInactiveAndObsoleteSolutionsCount]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetInactiveAndObsoleteSolutionsCount]
GO
CREATE PROCEDURE [dbo].[ws_GetInactiveAndObsoleteSolutionsCount]
AS
SELECT COUNT(1) as InactiveProcessCount
 from WFPROCESS WHERE Inactive =1;
 
WITH Solutions AS
(
    SELECT WSSLN.SolutionID,WSSLN.Name as solutionName,WFPROCDEF.Name as processName,
    ROW_NUMBER() OVER (Partition BY WFPROCDEF.Name order by WSSLN.SolutionID desc) AS RowNumber
    FROM WSSLN
    INNER JOIN WFPROCDEF ON WFPROCDEF.ID=WSSLN.ProcessDefinitionID
  )   

select COUNT(1) as ObsoleteSolutionCount 
from Solutions where RowNumber <> 1;
				
GO 

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetSiteAndListKeys]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetSiteAndListKeys]
GO
CREATE PROCEDURE [dbo].[ws_GetSiteAndListKeys] 

AS
BEGIN
SELECT *  FROM SVConfig;
END 
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetJobsToExport]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetJobsToExport]
GO
Create PROCEDURE [dbo].[ws_GetJobsToExport]
(
	@period NVarchar(50),
	@status NVarchar(15),
	@type Varchar(30)
) 
	AS
BEGIN
	Declare @query NVarchar(1000);
	Declare @whereClause NVarchar(1000);
	Declare @set BIT;
	Set @set =0;
	Set @query = 'Select [ID], Case [Status] 
									  WHEN 1 Then ''Pending''
									  WHEN 2 Then ''Completed''
									  WHEN 3 Then ''Error'' 
									  WHEN 4 Then ''Processing''
									  End as [STATUS], [Type], [ClassName] AS [CLASS NAME],[StartDate] AS [START]
									  ,[CompletionDate] as [STOPPED]
									  ,[ReferenceKey] AS [REF KEY]
									  ,[Owner] From SVService ';
	Set @whereClause = '';
	If LOWER(@period) <> 'all'
	 Begin
		Set @whereClause = @whereClause + ' [StartDate] >= ''' + @period + ''' ';
		Set @set = 1;
	 End
	
	If LOWER(@status) <> 'all'
	 Begin
		If @set = 1
			Set @whereClause = @whereClause + ' and [Status] = ' + @status;
		Else
		 Begin
			Set @whereClause = @whereClause + ' [Status] = ' + @status;
			Set @set = 1 ;
		 End
	 End
		
	If LOWER(@type) <> 'all'
	 If @set = 1
		Set @whereClause = @whereClause + ' and [Type] = ''' + @type + '''';
	 Else
		Set @whereClause = @whereClause + ' [Type] = ''' + @type + '''';
		
	If LEN(@whereClause) <> 0
	 Begin
		Set @query = @query + 'Where ' + @whereClause ;
	 End
	 
	 Set @query = @query +  ' Order By ID';
	
	EXEC sp_Executesql @query;
END
Go

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetJobs]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetJobs]
GO
Create PROCEDURE [dbo].[ws_GetJobs]
(
	@period NVarchar(50),
	@status NVarchar(15),
	@type Varchar(30),
	@pagesize INT,
	@pagenumber INT,
	@orderby Varchar(50),
	@ascdesc varchar(15)
) 
	AS
BEGIN
	Declare @recordCountQuery NVarchar(1500);
	Declare @finalQuery NVarchar(1500);
	Declare @query NVarchar(1000);
	Declare @whereClause NVarchar(1000);
	Declare @set BIT;
	Declare @from BIGINT;
	Declare @to BIGINT;
	Declare @orderByClause Varchar(100);
	Set @set =0;
	If @pagenumber < 0
		Set @pagenumber = 0;
	Set @from = (@pagesize * (@pagenumber-1)) + 1;
	Set @to = @pagesize * @pagenumber;
	
	If(LTRIM(RTRIM(@orderby)) = '')
		Begin
			Set @orderby = 'ID';
		End
		
	If(LTRIM(RTRIM(@ascdesc)) = '')
		Begin
			Set @ascdesc = 'DESC';
		End
	Set @orderByClause = 'Order By ' + @orderby + ' ' + @ascdesc;
	Set @query = 'Select [ID], [Type], [Status], Case [Status] 
									  WHEN 1 Then ''Pending''
									  WHEN 2 Then ''Completed''
									  WHEN 3 Then ''Error'' 
									  WHEN 4 Then ''Processing''
									  End as [StatusString], [ClassName],[StartDate]
									  ,[CompletionDate]
									  ,[ReferenceKey]
									  ,[Owner] From SVService ';
	
	Set @whereClause = '';
	If LOWER(@period) <> 'all'
	 Begin
		Set @whereClause = @whereClause + ' [StartDate] >= ''' + @period + ''' ';
		Set @set = 1;
	 End
	
	If LOWER(@status) <> 'all'
	 Begin
		If @set = 1
			Set @whereClause = @whereClause + ' and [Status] = ' + @status;
		Else
		 Begin
			Set @whereClause = @whereClause + ' [Status] = ' + @status;
			Set @set = 1 ;
		 End
	 End
		
	If LOWER(@type) <> 'all'
	 If @set = 1
		Set @whereClause = @whereClause + ' and [Type] = ''' + @type + '''';
	 Else
		Set @whereClause = @whereClause + ' [Type] = ''' + @type + '''';
		
	If LEN(@whereClause) <> 0
	 Begin
		Set @query = @query +  'Where ' + @whereClause;
	 End

	
	Set @recordCountQuery = 'Select Count(1) as RecordCount From SVService ';
	If LEN(@whereClause) <> 0
	 Begin
		Set @recordCountQuery =@recordCountQuery + 'Where ' + @whereClause;
	 End
	 
	 Set @finalQuery = 'With CTE1([ID], [Type], [Status], [StatusString], [ClassName],[StartDate],[CompletionDate],[ReferenceKey],[Owner]) As ('+
						@query + '),' +
						'CTE2([Rank],[ID], [Type], [Status], [StatusString], [ClassName],[StartDate],[CompletionDate],[ReferenceKey],[Owner]) AS (' + 
						'Select ROW_NUMBER() OVER (' + @orderByClause + ') AS [Rank], [ID], [Type], [Status], [StatusString], [ClassName],[StartDate],			
						 [CompletionDate],[ReferenceKey],[Owner] From CTE1) ' +
						'SELECT [ID], [Type], [Status], [StatusString], [ClassName],ISNULL([StartDate],'''') as StartDate,' +'[CompletionDate],[ReferenceKey],ISNULL([Owner], '''') as Owner FROM CTE2 Where [Rank] >= ' + Cast(@from as NVarchar) + ' and [Rank] <= ' + Cast(@to as NVarchar);
	Print @finalquery;
	Print @recordCountQuery;
	EXEC sp_Executesql @recordCountQuery;
	EXEC sp_Executesql @finalquery;
END
Go

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[ws_GetJobTypes]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [ws_GetJobTypes]
GO
Create PROCEDURE [dbo].[ws_GetJobTypes] 
	AS
BEGIN
	Select Distinct Type FROM [SVSERVICE];
END
Go
