﻿var ws_initializeWebApp = function (url, target, callback) {

    ws_ajaxCall(url, null, function (data, callbackdata) {
        $(target).find('option').remove();
        var options = getOption(data);
        $(target).append($(options));
        var server = wsPlugin_getURLParameter('server');
        if (server != null && server != undefined && server.length > 0) {
            $.each($(target).find('option'), function (index, value) {
                if ($(this).val().toLowerCase() == server.toLowerCase()) {
                    $(this).attr('selected', 'selected');
                }
            });
        }

        SetupAllLinks();
        // callback after this.
        if (callback != null && callback != undefined) {
            callback(data, callbackdata);
        }
    }, null, null);

    function getOption(data) {
        var option = '';

        $.each(data, function (k, v) {
            option += '<option value="' + v.WebAppUrl + '">' + v.Name + '</option>';
        });

        return option;
    }
}

function ws_ajaxCall(url, data, callbackSuccess, callbackError, callbackdata) {
    $.ajax({
        url: url,
        data: data,
        cache: false,
        success: function (data) {
            if (callbackSuccess != null && callbackSuccess != undefined) {
                callbackSuccess(data, callbackdata);
            }
            else {
                ws_hideProgressBar();
            }
        },
        error: function (xhr, status, error) {
            if (callbackError != null && callbackError != undefined) {
                callbackError(xhr, status, error, callbackdata);
            }
            else {
                ws_hideProgressBar();
            }
        }
    });
}

var ws_initializeDropdown = function (url, data, target, callbackSuccess, callbackFailure, callbackdata, clearfirstitem, fillOptions) {

    ws_ajaxCall(url, data, function (data, callbackdata) {
        if (clearfirstitem == true) {
            $(target).find('option').remove();
        }
        else {
            $(target).find('option').first().siblings('option').remove();
        }

        var options;
        if (fillOptions != null) {
            options = fillOptions(data);
        }
        else {
            options = getOption(data);
        }

        $(target).append($(options));

        // callback after this.
        if (callbackSuccess != null && callbackSuccess != undefined) {
            callbackSuccess(data, callbackdata);
        }
    }, function (xhr, status, error) {
        // callback after this.
        if (callbackFailure != null && callbackFailure != undefined) {
            callbackFailure(xhr, status, error, callbackdata);
        }
    }, null);

    function getOption(data) {
        var option = '';
        $.each(data, function (k, v) {
            option += '<option value="' + v.Value + '">' + v.Text + '</option>';
        });
        return option;
    }
}

function loadXMLString(txt) {
    var xmlDoc = null;
    try {
        xmlDoc = $.parseXML(txt)
    }
    catch (e) {
    }

    return xmlDoc;
}

function isValidXMLString(txt) {
    var theReturn = true;
    if (txt == null || txt == undefined) {
        theReturn = false;
    }
    else {
        try {
            var returned = loadXMLString(txt);
            if (returned == null) {
                theReturn = false;
            }
        }
        catch (e) {
            theReturn = false;
        }
    }

    return theReturn;
}

function ws_showProgressBar() {
    $(document.body).append('<div id="div-loading-elmt"><img alt="loading" id="img-loading-elmt" src="/Content/assets/img/loading.png"/></div>');
    var left = $(window).width() / 2;
    var top = $(window).height() / 2;
    $('#div-loading-elmt').css('display', 'block');
    $('#img-loading-elmt').css({ top: top, left: left });
}

function ws_hideProgressBar() {
    $(document.body).find('#div-loading-elmt').remove();
}

function ws_getEncodedData(data) {
    return $('<div/>').text(data).html();
}

var ws_encodeSpecialHTMLChars = function (html) {
    return html.replace(/>/g, '&gt;')
                    .replace(/</g, '&lt;')
                    .replace(/"/g, '&quot;');
}

function ws_getDecodedData(data) {
    return $('<div/>').html(data).text();
}

function validateClientSide(containerId) {

    var invalidItems = new Array();
    var defaultMessage = 'This is a required field.';

    /**Required validation**/
    var requiredElmts = $('#' + containerId).find('[validation-type*="required"]');
    $.each(requiredElmts, function (key, value) {

        if (!$(value).is(':visible')) {
            return;
        }

        var invalidVal = '';
        var val = '';

        var ctrlType = $(value).prop('type').toLowerCase();
        if (ctrlType == 'select-one') {
            invalidVal = ['n/a', '_cancel', 'select', null, undefined];
            val = $(value).find("option:selected").val();

            $(value).on('change', function () {
                $this = $(this);
                var tempVal = $this.find('option:selected').val().toLowerCase();
                if ($.inArray(tempVal, invalidVal) < 0) {
                    $this.removeClass('input-validation-error');
                    removeSpanElement($this);
                }
                else {
                    var $message = $this.attr('required-message');
                    if ($message == null || $message == undefined) {
                        $message = "This is a required field.";
                    }

                    createSpanElement($this, $message, 'field-validation-error');
                    $this.addClass('input-validation-error');
                }
            });
        }
        else if (ctrlType == "file") {
            invalidVal = [''];

            if ($(this).hasClass('js-kendo-fileupload')) {

                val = $(this).closest('div.kendo-ui-file').find('span.k-filename').text();
            }
            else {
                val = $(this).val();
            }

            $(value).on('change', function () {
                var $this = $(this);
                var $message = $this.attr('required-message');
                if ($message == null || $message == undefined) {
                    $message = "This is a required field.";
                }

                var $temp = $('#' + $(this).attr('name')).closest('div.kendo-ui-file');

                if ($(this).val() == '') {
                    createSpanElement($temp, $message, 'field-validation-error');
                    $temp.addClass('input-validation-error');
                }
                else {
                    $temp.removeClass('input-validation-error');
                    removeSpanElement(this);
                }
            });
        }
        else if (ctrlType == 'text' || ctrlType == 'textarea' || ctrlType == 'password') {
            invalidVal = [''];
            val = $.trim($(value).val());

            $(value).on('blur', function () {
                validateOnBlur(this, invalidVal);
            });
        }

        if (val != null && val != undefined) {
            val = val.toLowerCase();
        }

        if ($.inArray(val, invalidVal) >= 0) {
            var message = $(value).attr('required-message');
            if (message == undefined || message == '') {
                message = defaultMessage;
            }

            appendValidateMessage(value, message);

            invalidItems.push($(value).attr('id'));
        }
        else {

            $(value).removeClass('input-validation-error');
            removeSpanElement(value);
        }
    });

    /**Regex validation**/
    var regexElmts = $('#' + containerId).find('[validation-type*="regex"]');
    $.each(regexElmts, function (key, value) {
        if (!$(value).is(':visible')) {
            return;
        }

        if ($.inArray($(value).attr('id'), invalidItems) >= 0) {
            return;
        }

        $(value).on('blur', function () {
            validateOnBlur(this, ['']);
        });

        var regex = new RegExp($(value).attr('validation-regex'));
        var val = $(value).val();

        if (val != '' && !regex.test(val)) {
            appendValidateMessage(value, $(value).attr('regex-message'));

            invalidItems.push($(value).attr('id'));
        }
        else {
            $(value).removeClass('input-validation-error');
            removeSpanElement(value);
        }
    });

    return invalidItems.length == 0;
}

function createSpanElement(appendAfter, message, cssClass) {

    var id = $(appendAfter).attr('id');

    $('#' + id + '-validationMessage').remove();
    var span = '<span id="' + id + '-validationMessage" class="' + cssClass + '">' + message + '</span>';
    $(appendAfter).after($(span));
}

function removeSpanElement(obj) {
    var id = $(obj).attr('span-id');
    $('#' + id).remove();
}


function appendValidateMessage(obj, message) {
    var ctrlType = $(obj).prop('type').toLowerCase();
    var spanId = '';

    //js-kendo-datepicker
    if ($(obj).hasClass('js-kendo-datepicker')) {
        // date element
        var ulElmt = $(obj).closest('ul.date-group');
        spanId = ulElmt.attr('id') + '-validationMessage';
        createSpanElement(ulElmt, message, 'field-validation-error');
    }
    else if ($(obj).hasClass('js-kendo-timepicker')) {
        // date element
        var spanElmt = $(obj).closest('span.js-kendo-timepicker');
        spanId = spanElmt.attr('id') + '-validationMessage';
        createSpanElement(spanElmt, message, 'field-validation-error');
    }
    else if ($(obj).hasClass('js-kendo-fileupload')) {
        // kendo-ui file upload
        var spanElmt = $(obj).closest('div.kendo-ui-file');
        spanElmt.attr('id', 'div-kendo-ui-file');
        spanId = spanElmt.attr('id') + '-validationMessage';
        spanElmt.addClass('input-validation-error');
        createSpanElement(spanElmt, message, 'field-validation-error');
    }
    else if (ctrlType == 'textarea') {
        // textarea
        var divElmt = $(obj).closest('div');
        spanId = divElmt.attr('id') + '-validationMessage';
        createSpanElement(divElmt, message, 'field-validation-error');
    }
    else {
        spanId = $(obj).attr('id') + '-validationMessage';
        createSpanElement(obj, message, 'field-validation-error');
    }

    $(obj).attr('span-id', spanId);
    $(obj).addClass('input-validation-error');
}


function validateOnBlur(obj, invalidVal) {
    $this = $(obj);
    var passFlag = true;

    var required = $this.is('[validation-type*="required"]');
    if (required) {
        var $message = $this.attr('required-message');
        var tempVal = $.trim($this.val());
        passFlag = $.inArray(tempVal, invalidVal) < 0;
    }

    if (passFlag) {
        var regex = $this.is('[validation-type*="regex"]');
        if (regex) {
            var regexp = new RegExp($(obj).attr('validation-regex'));
            $message = $this.attr('regex-message');
            var tempVal = $this.val();
            passFlag = (tempVal == '' || regexp.test(tempVal));
        }
    }

    if (passFlag) {
        $this.removeClass('input-validation-error');
        removeSpanElement($this);
    }
    else {
        if ($message == null || $message == undefined) {
            $message = "This is a required field.";
        }

        appendValidateMessage($this, $message);
    }
}

function SetupLinks() {
    var windowlocation = window.location.href;
    if (windowlocation != null && windowlocation != undefined) {
        var key = 'server';
        var value = $('#select-webapp').val();
        var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
        var separator = windowlocation.indexOf('?') !== -1 ? "&" : "?";
        if (windowlocation.match(re)) {
            windowlocation = windowlocation.replace(re, '$1' + key + "=" + value + '$2');
        }
        else {
            windowlocation = windowlocation + separator + key + "=" + value;
        }

        window.location.href = windowlocation;
    }

    return false;
}

function SetupAllLinks() {
    var anchors = $('#workflow-header, #breadcrumbs, ul.home-links-64px, .tableHeader-menu').find('a');
    $.each(anchors, function () {
        var hrefattr = $(this).attr('href');
        if (hrefattr != null && hrefattr != undefined && hrefattr != '#' && (hrefattr.toLowerCase().indexOf('http://') != 0)) {
            var key = 'server';
            var value = $('#select-webapp').val();
            var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
            var separator = hrefattr.indexOf('?') !== -1 ? "&" : "?";
            if (hrefattr.match(re)) {
                hrefattr = hrefattr.replace(re, '$1' + key + "=" + value + '$2');
            }
            else {
                hrefattr = hrefattr + separator + key + "=" + value;
            }

            $(this).attr('href', hrefattr);
        }
    });
}

function BindEnterKeyEvent(controls, btnControl) {
    controls.bind("keydown", function (event) {
        var keycode = (event.keyCode ? event.keyCode : (event.which ? event.which : event.charCode));
        if (keycode == 13) {
            btnControl.click();
            return false;
        } else {
            return true;
        }
    });
}

(function ($) {
    $.fn.applySorting = function (callback) {

        var sortClass = {
            "NoSort": "no-sort",
            "Ascending": "sortup",
            "Descending": "sortdown"
        };

        var sortIndicator = {
            "NoSort": "NoSort",
            "Ascending": "Ascending",
            "Descending": "Descending"
        };

        var th = this.find('th[sort-key]');
        $.each(th, function (key, value) {
            if($(value).attr('sort-indicator') == null || $(value).attr('sort-indicator') == undefined)
            {
                $(value).attr('sort-indicator', sortIndicator.NoSort);
            }

            $(value).bind('sort', callback);
            $(value).on('click', function () {

                var $this = $(this);
                $this.siblings('th[sort-key]').attr('sort-indicator', sortIndicator.NoSort).removeClass(sortClass.Descending).removeClass(sortClass.Ascending);
                var curSort = $this.attr('sort-indicator');
                var sortKey = $this.attr('sort-key');

                if (curSort == sortIndicator.Ascending) {
                    // up sorting applied
                    // apply descending sorting [down sorting]
                    $this.attr('sort-indicator', sortIndicator.Descending);
                    $this.removeClass(sortClass.NoSort).removeClass(sortClass.Ascending);
                    $this.addClass(sortClass.Descending);

                    // trigger event
                    $this.trigger('sort', { SortKey: sortKey, SortOrder: "Descending" });
                }
                else if (curSort == sortIndicator.NoSort || curSort == sortIndicator.Descending) {
                    // down sorting applied
                    // apply ascending sorting [up sorting]
                    $this.attr('sort-indicator', sortIndicator.Ascending);
                    $this.removeClass(sortClass.NoSort).removeClass(sortClass.Descending);
                    $this.addClass(sortClass.Ascending);

                    // trigger event
                    $this.trigger('sort', { SortKey: sortKey, SortOrder: "Ascending" });
                }
            });
        });
    };
} (jQuery));