﻿<%@ Page Title="Charts" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Charts
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Charts</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/WorkflowDump">Excel Workflow Data Dump</a></li>
                                    <li class="link"><a href="/LogViewer">Log File Viewer</a></li>
                                    <li class="link"><a href="/DatabaseUsage">Database Status</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Charts</h1>
                            </li>
                        </ul>
                    </div>
                    <div>
                        <span id="js-notice-message"></span>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span6">
                        <div>
                            <form id="form-control">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Site <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id="select-site"></select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Report Type <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id="select-reporttype" validation-type="required" required-message="Report Type is required field."></select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Process <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id="select-process" validation-type="required" required-message="Process is required field."></select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Report Period <span class="required">*</span></label>
                                        <div class="controls">
                                        <ul class="date-group date small" id="daterange">
                                            <li>
                                                <input id="input-startdate" type="text" class="js-kendo-datepicker form-control input-small" placeholder="Start Date" validation-type="required,regex" required-message="Report Period is a required field." validation-regex="^([1-9]|1[012])/([1-9]|[12][0-9]|3[01])/\d{4}$" regex-message="date should be in the format mm/dd/yyyy"/>
                                            </li>
                                            <li>
                                            <input id="input-enddate" type="text" class="js-kendo-datepicker form-control input-small" placeholder="End Date" validation-type="required,regex" required-message="Report period is a required field." validation-regex="^([1-9]|1[012])/([1-9]|[12][0-9]|3[01])/\d{4}$" regex-message="date should be in the format mm/dd/yyyy"/>
                                            </li>
                                        </ul>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Chart Type <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id="select-charttype" validation-type="required" required-message="Chart Type is a required field."></select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Chart Title</label>
                                        <div class="controls">
                                            <input type="text" id="input-title" class="form-control input-block-level input-max" placeholder=""/>
                                        </div>
                                    </div>
                                </fieldset>
                                
                                <fieldset class="form-horizontal">
                                    <div class="form-actions">
                                        <button id="btn-submit" class="btn btn-primary"><span>Continue</span></button>
                                        <button class="btn" id="btn-cancel"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span6 -->
                    <div class="chart span6">
                        <h3><a href="#" id="anchor-reporttype">No Report Generated</a></h3>
                        <div class="chart-content" id="div-chart"></div>
                        <%--<p>Report Period: mm/dd/yyyy - mm/dd/yyyy</p>--%>
                    </div>
                    <!-- /div .span6 -->
                </div>

                <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>

            $(document).ready(function () {

                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {
                    var webapp = $('#select-webapp').val();
                    ws_ajaxCall('/admin/getallsites', { server: webapp }, loadSite, loadSiteError, null);
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });

                $("#select-site").on('change', function () {
                    ws_showProgressBar();
                    loadControls();
                });

                $("#select-reporttype").on('change', function () {
                    ws_showProgressBar();
                    onReportChange();
                });

                $('#btn-submit').on('click', function () {
                    if (!validateClientSide('form-control')) {
                        return false;
                    }

                    var startDate = new Date($('#input-startdate').val());
                    var endDate = new Date($('#input-enddate').val());

                    if (startDate > endDate) {

                        $('#input-startdate,#input-enddate').addClass('input-validation-error');
                        $('#daterange').closest('div.control-group').find('span.js-daterange-validate').remove();
                        $('#daterange').after('<span class="js-daterange-validate field-validation-error">Start date can not be greater than End date.</span>');
                        $('#input-startdate,#input-enddate').off('change').on('change', function () {

                            $('#input-startdate,#input-enddate').removeClass('input-validation-error');
                            $('#daterange').closest('div.control-group').find('span.js-daterange-validate').remove();
                            $('#input-startdate,#input-enddate').off('change');
                        });
                        return false;
                    }

                    ws_showProgressBar();
                    onSubmit();
                    return false;
                });

                $('#btn-cancel').on('click', function () {
                    var webapp = $('#select-webapp').val();
                    window.location.href = "/home?server=" + webapp;
                    return false;
                });
            });

            function onSubmit() {

                var site = $('#select-site option:selected').val();
                var reportType = $('#select-reporttype option:selected').val();
                var process = $('#select-process option:selected').text();
                var chartType = $('#select-charttype option:selected').val();
                var startDate = $('#input-startdate').val();
                var endDate = $('#input-enddate').val();
                var height = $('#input-height').val();
                var width = $('#input-width').val();
                var title = $('#input-title').val();
                var width = $('#div-chart').width();
                var height = $('#div-chart').height();

                var data = { site: site, reportType: reportType, process: process, chartType: chartType, startDate: startDate, endDate: endDate, title: title, width: width, height: height };
                $('#anchor-reporttype').html($('#select-reporttype option:selected').text());
                var image = new Image();
                $(image).load(function () {
                    $('#div-chart').html('').append(this);
                    ws_hideProgressBar();
                })
                .error(function () {
                    // error while loading image
                    ws_ajaxCall('/chart/retrieveerror', null, function (data) {

                        $('#div-chart').html(data);
                        ws_hideProgressBar();

                    }, null, null);
                })
                .attr('src', '/chart/Draw?' + $.param(data));
            }

            function callOnError() {
                ws_hideProgressBar();
            }

            function callbackAfterSubmitSuccess(data, callbackdata) {
                $('#div-chart').append(callbackdata);
                $(callbackdata).fadeIn();
                ws_hideProgressBar();
            }

            function loadSite(data, callbackdata) {

                var options = '';
                if (data != undefined && data != null && data.length > 0) {
                    $.each(data, function (key, value) {
                        options += '<option value="' + value.URL + '">' + value.ServerRelativeURL + '</option>';
                    });

                    $("#select-site option").remove();
                    $("#select-site").append(options);

                    loadControls();
                }
                else {
                    ws_hideProgressBar();
                }
            }

            function loadControls() {

                var site = $('#select-site option:selected').val();
                var webapp = $('#select-webapp option:selected').val();

                ws_ajaxCall('/chart/Detail', { server: webapp, site: site }, fillControls, loadSiteError, null);
            }

            function loadSiteError(xhr, statur, error) {

                ws_hideProgressBar();

                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                }
            }

            function fillControls(data) {

                var reportType = $('#select-reporttype');
                var process = $('#select-process');
                var chartType = $('#select-charttype');

                fillSelect(data.ReportTypes, reportType);
                fillSelect(data.ProcessNames, process);
                fillSelect(data.ChartTypes, chartType);
                $('#select-reporttype').val(data.SelectedReportType);

                if (data.SelectedReportType == 5) {
                    $('<option value="-1"></option>').insertBefore($('#select-process option:eq(0)'));
                    $('#select-process').attr('disabled', true);
                    $('#select-process option[value=-1]').attr('selected', 'selected');
                }
                else {
                    $('#select-process option["value=-1"]').remove();
                    $('<option value="-1"></option>').insertBefore($('#select-process option:eq(0)'));
                    $('#select-process').attr('disabled', false);
                }

                ws_hideProgressBar();
            }

            function fillSelect(data, selectElmt) {

                $(selectElmt).find('option').remove();

                var options = '';
                $.each(data, function (key, value) {
                    options += '<option value="' + key + '">' + value + '</option>';
                });

                if (options == '') {
                    options = '<option value="N/A">No Data Found</option>';
                }

                $(selectElmt).append(options);

                return options;
            }

            function onReportChange() {
                var site = $('#select-site option:selected').val();
                var webapp = $('#select-webapp option:selected').val();
                var report = $('#select-reporttype option:selected').val();

                if (report == 5) {
                    $('<option value="-1"></option>').insertBefore($('#select-process option:eq(0)'));
                    $('#select-process').attr('disabled', true);
                    $('#select-process option[value=-1]').attr('selected', 'selected');
                }
                else {
                    $('#select-process option[value=-1]').remove();
                    $('#select-process').attr('disabled', false);
                }

                ws_ajaxCall('/chart/GetChartTypes', { server: webapp, site: site, reportType: report }, fillChartType, loadSiteError, null);
            }

            function fillChartType(data) {
                var chartType = $('#select-charttype');
                fillSelect(data, chartType);
                ws_hideProgressBar();
            }
        </script>
</asp:Content>
