﻿<%@ Page Title="Winshuttle Workflow SharePoint Farm Configurations" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Winshuttle Workflow SharePoint Farm Configurations
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
    <div class="span12">
        <ul id="breadcrumbs">
            <li><a href="/Home">Administration</a> &rsaquo;</li>
            <li>Winshuttle Workflow SharePoint Farm Configurations</li>
        </ul>
        <ul id="secnav">
            <li class="active">
                <h1>Winshuttle Workflow SharePoint Farm Configurations</h1>
                <div class="row-fluid">
                    <div class="span8 page-description">User can set the Farm level keys from here.
                    <br /><span><b>Note: No validations are done for user input. Please provide property values carefully.</b></span></div>
                </div>                
            </li>
        </ul>
    </div>
    </div>
    <div class="control-group">
        <span id="js-notice-message"></span>
    </div>
    <div id="div-key-content">
        <div class="span12">
            <h2>Farm Keys</h2>
            <table id="table-farm-keys" class="table table-striped table-bordered table-addedit-form">
                <thead>
                    <tr>
                        <th width="33%"><a href="#">Name</a></th>
                        <th width="67%"><a href="#">Value</a></th>
                    </tr>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>    
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
    <script>
        if (!window.jQuery) {
            console.error("jQuery CDN is down.")
            document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
        }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
    <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/jquery.tmpl.js") %>"></script>
    <script type="text/javascript">
        var webpapps = undefined;
        $(document).ready(function () {

            ws_showProgressBar();
            ws_initializeWebApp('/farmconfiguration/fetchallfarmlevelwebapp', $('#select-webapp'), function (data) {
                if (data.Status == undefined && data.Data == undefined) {
                    $.each(data, function (k, v) {
                        $('#select-webapp').find('option[value="' + v.WebAppUrl + '"]').attr('guid', v.Id);
                    });

                    var webapp = $('#select-webapp option:selected').attr('guid');
                    ws_ajaxCall('/farmconfiguration/getfarmkeyvalue', { webapp: webapp }, onLoad, onError, null);
                }
                else if (data.Status == 'Unauthorized') {
                    $('#div-key-content').html('');
                    wsLib_createBootstrapAlert($('#js-notice-message'), data.Data, "error", false);
                    ws_hideProgressBar();
                }
            });

            $('#select-webapp').on('change', function () {
                SetupLinks();
            });

            function onLoad(data) {

                createRow(data);
                ws_hideProgressBar();
            }

            function onError(xhr, status, error) {
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                }

                ws_hideProgressBar();
            }
        });

        function createRow(data) {
            $('#table-farm-keys>tbody').find('tr').remove();
            $('#farm-key-template').tmpl(data).appendTo('#table-farm-keys>tbody');

            $('#table-farm-keys tr').find('i.icon-edit').on('click', function () {

                var $this = $(this);
                $this.closest('td').find('div#div-normal').css('display', 'none');
                $this.closest('td').find('div#div-edit').css('display', '');

                var keyVal = $this.closest('td').find('div#div-normal>div#div-key-value').html();
                $this.closest('td').find('div#div-edit').find('input[type="text"]').val(keyVal);

                $this.closest('td').find('div#div-edit').find('#button-save').off('click').on('click', function () {
                    var $td = $(this).closest('td');
                    var editedVal = $td.find('div#div-edit').find('input[type="text"]').val();
                    var keyName = $td.closest('tr').find('td:eq(0) label').text();
                    var webapp = $('#select-webapp option:selected').attr('guid');
                    ws_showProgressBar();

                    ws_ajaxCall('/farmconfiguration/updatefarmkey', { webapp: webapp, key: keyName, value: editedVal },
                    function (data, callbackdata) {
                        $(callbackdata).find('div#div-normal').css('display', '');
                        $(callbackdata).find('div#div-edit').css('display', 'none');
                        var tempEditedVal = $(callbackdata).find('div#div-edit').find('input[type="text"]').val();
                        $(callbackdata).find('div#div-normal>div#div-key-value').html(tempEditedVal);

                        wsLib_createBootstrapAlert($('#js-notice-message'), data, "success", true);
                        ws_hideProgressBar();
                    },
                    function (xhr, status, error) {
                        if (xhr.statusText != null && xhr.statusText != undefined) {
                            wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                        }
                        else {
                            wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                        }

                        ws_hideProgressBar();
                    },
                    $td);
                });

                $this.closest('td').find('div#div-edit').find('#button-cancel').on('click', function () {
                    var $td = $(this).closest('td');
                    $td.find('div#div-normal').css('display', '');
                    $td.find('div#div-edit').css('display', 'none');
                });
            });
        }
    </script>

    <script id="farm-key-template" type="text/x-jquery-tmpl">
    <tr>
        <td>
            <label>${Name}</label>
        </td>
        <td>
            <div id="div-normal">
                <div id="div-key-value">${Value}</div>
                <div class="pull-right">
                    <a href="#">
                        <i class="icon-edit"></i>
                    </a>
                </div>
            </div>
            <div id="div-edit" style="display:none;">
                <div><input type="text" class="form-control input-mid" /></div>
                <div class="add-actions pull-right">
                    <button id="button-save" class="btn btn-primary"><span>Add</span></button>
                    <button id="button-cancel" class="btn"><span>Cancel</span></button>
                </div>
            </div>
        </td>
    </tr>
    </script>
</asp:Content>
