﻿<%@ Page Title="Front End Configuration" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Front End Configuration
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
    <div class="span12">
        <ul id="breadcrumbs">
            <li><a href="/Home">Administration</a> &rsaquo;</li>
            <li>Front End Configuration</li>
        </ul>
        <ul id="secnav">
            <li class="active">
                <h1>Front End Configuration</h1>
                <p class="page-description">This command is required to be run when a new web front end is added to the farm. It will configure Winshuttle Workflow on the newly added front end.
                    Only Workflow Administrator can run this command.
                <br />
                    <span>NOTE: All the web front ends in the farm will be listed here. Please select only the web front end where Winshuttle Workflow is to be configured.</span>
                </p>
            </li>
        </ul>
    </div>
</div>
<div class="row-fluid">
    <div class="span8">
        <div class="settings-info">
            <form class="form-horizontal">
                <fieldset>
                    <div class="control-group">
                        <span id="js-notice-message"></span>
                    </div>
                    <div class="control-group">
                        <label class="control-label">Front Ends To Configure</label>
                        <div class="controls">
                            <ul id="ul-front-end"></ul>
                        </div>
                    </div>
                    <div class="form-actions top-line">
                        <button class="btn btn-primary" id="button-continue"><span>Continue</span></button>
                        <button class="btn" id="button-cancel"><span>Cancel</span></button>
                    </div>
                </fieldset>
            </form>
        </div>
    </div>
    <!-- /div .span8 -->
</div>
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
<script>
    if (!window.jQuery) {
        console.error("jQuery CDN is down.")
        document.write('<script src="<%=Url.Content("~/content/assets/js/jquery.min.js") %>"><\/script>');
    }
</script>
<script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
<script>
    if (!$.fn.modal) {
        console.error("Bootstrap CDN is down.")
        document.write('<script src="<%=Url.Content("~/content/assets/js/bootstrap.min.js") %>"><\/script>');
    }
</script>
<script src="<%=Url.Content("~/content/assets/js/kendo.all.min.js") %>"></script>
<script src="<%=Url.Content("~/content/assets/js/chosen.jquery.min.js") %>"></script>
<script src="<%=Url.Content("~/content/assets/js/wslib_master.js") %>"></script>
<script src="<%=Url.Content("~/content/assets/js/wsplugin_master.js") %>"></script>
<script src="<%=Url.Content("~/content/assets/js/ws_global_initialization_administration.js") %>"></script>
<script src="<%=Url.Content("~/content/assets/js/ws_common.js") %>"></script>

<script>
    $(document).ready(function () {
        ws_showProgressBar();
        $("#select-webapp").change(function () {
            SetupLinks();
        });
        ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {

            ws_ajaxCall('/frontendconfiguration/fetchallfrontends', null, function (data, callbackdata) {

                var frontEnds = '';
                if (data == null || data == undefined || data.length == 0) {

                    // no data found.
                    frontEnds = 'No front end found.';
                    $('#button-continue').attr('disbaled', true);
                }
                else {
                    $.each(data, function (key, value) {

                        frontEnds += '<li><input type="checkbox" value="' + value + '" />&nbsp;&nbsp;' + value + '</li>';
                    });
                }

                $('#ul-front-end').html(frontEnds);

                ws_hideProgressBar();
            });
        });

        $('#button-cancel').on('click', function () {
            window.location.href = '/Home?server=' + $('#select-webapp').val();
            return false;
        });

        $('#button-continue').on('click', function () {

            if (!validateFrontEnds()) {

                return false;
            }

            var data = new Array();
            var checkedFE = $('#ul-front-end input[type="checkbox"]:checked');
            checkedFE.each(function (k, v) {
                data.push($(v).val());
            });

            ws_showProgressBar();
            $('#div-message').html('');

            $.ajax({
                url: '/frontendconfiguration/executejob',
                data: { servers: data },
                cache: false,
                traditional: true,
                success: function (data) {

                    var message = 'The following timer jobs have been successfully scheduled.  Please verify these jobs have been successfully executed in SharePoint Central Admin to ensure Workflow has been successfully configured.<div><br /><ul class="bulleted">';

                    $.each(data, function (k, v) {
                        message += '<li>' + v + '</li>';
                    });

                    message += '</ul></div>';
                    wsLib_createBootstrapAlert($('#js-notice-message'), message, "success", true);
                    ws_hideProgressBar();
                },
                error: function (xhr, status, error) {
                    if (xhr.statusText != null && xhr.statusText != undefined) {
                        wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                    }
                    else {
                        wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                    }

                    ws_hideProgressBar();
                }
            });

            return false;
        });
    });

    function validateFrontEnds() {

        if ($('#ul-front-end input[type="checkbox"]:checked').length == 0) {

            $('#ul-front-end').addClass('input-validation-error');
            wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_FrontEndConfiguration_SelectFrontEnd %>', "error", true);
            setTimeout(function () {
                $('#ul-front-end').removeClass('input-validation-error');
            }, 3000);

            return false;
        }

        return true;
    }
        </script>
</asp:Content>
