﻿<%@ Page Title="Configure Options" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Configure Options
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <div class="row-fluid">
        <div class="span12">
            <ul id="breadcrumbs">
                <li><a href="/Home">Administration</a> &rsaquo;</li>
                <li>Configure Options</li>
                <li class="related-links">
                    <ul>
                        <li class="related-label">Related:</li>
                        <li class="link"><a href='http://cdn.winshuttle.com/products/help/winshuttle-foundation-help-center/index.htm#options.htm'>
                        Configuration Documentation</a></li>
                    </ul>
                </li>
            </ul>
            <ul id="secnav">
                <li class="pull-right">
                    <button class="btn pull-right" onclick='AddConfigButton();'>
                        <span>Add Configuration</span></button>
                </li>
                <li class="active">
                    <h1>
                        Configure Options</h1></li>
            </ul>
        </div>
    </div>
    <div class="control-group">
        <span id="js-notice-message"></span>
    </div>
    <div class="row-fluid">
        <table class="table table-header">
            <tbody>
                <tr>
                    <td>
                        <form>
                        <div>
                            <label>
                                Name Contains</label>
                            <input type="text" id='txtNameFilter' class="form-control input-large" placeholder="">
                        </div>
                        <div>
                            <label>
                                Scope</label>
                            <div id="strDropDown" class="js-dropdowntree-target dropdown-tree-menu keymainpage-dropdown">
                            </div>
                        </div>
                        <div>
                            <label>
                                Display Keys</label>
                            <select name="" id="keyvaluestatusdropdown" class="input-large">
                                <option selected="selected" value="1">With Values Assigned</option>
                                <option value="2">With NO Values Assigned</option>
                                <option value="3">All available Keys</option>
                            </select>
                        </div>
						<div>
							<label>&nbsp;</label>
							<button id="btnSearch" class="btn btn-primary"><span>Search</span></button><!-- btn-primary-->
						</div>
                        </form>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    <!-- /div .row-fluid -->
    <div class="row-fluid">
        <table id="table-KeysData" class="table table-striped table-bordered">
            <thead>
                <tr class="table-menu">
                    <th colspan="8">
                        <div class="display">
                            <span id="rowDisplay"></span>
                            <select name="" id="dropdownpagesize" class="input-small">
                                <option selected="selected" value="10">10</option>
                                <option value="20">20</option>
                                <option value="50">50</option>
                                <option value="100">100</option>
                            </select>
                        </div>
                    </th>
                </tr>
                <tr class="table-sort">
                    <th width="25%"  sort-indicator="Ascending" class="sortup" sort-key="Name">
                        <a href="#">Name</a>
                    </th>
                    <th width="15%">
                        <a href="#">Assigned to</a>
                    </th>
                    <th width="5%" sort-key="Type">
                        <a href="#">Type</a>
                    </th>
                    <th width="55%" class="no-sort">
                        Description
                    </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
        <div id="div-paging">
            <ul id="pagination-elmt" class="pagination-sm">
            </ul>
        </div>
    </div>
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
   <script>
       if (!window.jQuery) {
           console.error("jQuery CDN is down.")
           document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
       }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
     </script>
    <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/ws_admincommands.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/jquery.twbsPagination.min.js") %>"></script>
    <script>
        var dropdownMarkup = undefined;
        var orderSort = 'ASC';
        var pagenumber = 1;
        var orderby = 'Name';
        var _globalMessage = '<%=TempData["KeyMessages"] %>';
        $(document).ready(function () {
            ws_showProgressBar();
            clearPaging();
            ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);
            resetScopeDropDown();
            $('#txtNameFilter').val("");
            $("#dropdownpagesize").change(function () {
                wsLib_destroyBootstrapAlert($('#js-notice-message'));
                ws_showProgressBar();
                pagenumber = 1;
                _globalMessage = '';
                clearPaging();
                GetAllKeys();
            });

            BindEnterKeyEvent($("#txtNameFilter"), $("#btnSearch"));

            $("#btnSearch").click(function (event) {
                event.preventDefault();
                wsLib_destroyBootstrapAlert($('#js-notice-message'));
                ws_showProgressBar();
                pagenumber = 1;
                _globalMessage = '';
                clearPaging();
                resetScopeDropDown();
                GetAllKeys();
            });

            $('#select-webapp').change(function () {
                SetupLinks();
            });
        });

        function AddConfigButton() {
            window.location.href = '/KeyConfiguration/AddKey?server=' +$('#select-webapp').val();
            return false;
        }

        function resetScopeDropDown() {
            var $element = $('.js-administration-dropdowntree-select-display');
            var $type = $element.attr('type');
            if ( $type == undefined || $type.toLowerCase() == 'all') {
                $('.table-sort th:eq(1) a').text('Assigned to');
                $('.table-sort th:eq(1)').removeAttr('sort-key').addClass('no-sort');
            }
            else {
                $('.table-sort th:eq(1) a').text('Value');
                $('.table-sort th:eq(1)').attr('sort-key', 'Value').removeClass('no-sort');
            }

            ApplySorting();
        }

        function OnLoad() {
            PopulateDropDown();
            return false;
        }

        function PopulateDropDown() {
            ws_ajaxCall('/keyconfiguration/GetKeyDropdownStr', { server: $('#select-webapp').val()
            }, function (data) {
                var xml = $(loadXMLString(data));
                var str = MakeStructure(xml);
                $('#strDropDown').data('activedata', -1);
                $('#strDropDown').html('');
                $('#strDropDown').html(str);
                var $editConfigurationAddNewValueSelect = $('#strDropDown');
                var $editConfigurationAddNewValueSelectA = $('#strDropDown .dropdown-menu a');
                $editConfigurationAddNewValueSelect.off('click.scrollToItem').on('click.scrollToItem', '.dropdown-toggle', function (event) {
                    event.preventDefault();
                    var $currentDropdownMenu = $editConfigurationAddNewValueSelect.find('.dropdown-menu');
                    $currentDropdownMenu.css('width', $editConfigurationAddNewValueSelect.width() + 'px');
                    var activedata = $editConfigurationAddNewValueSelect.data('activedata');
                    if (activedata !== undefined && activedata != -1) {
                        setTimeout(function () {
                            var container = $editConfigurationAddNewValueSelect.find('.dropdown-menu');
                            var scrollTo = $(container).find('a').filter('[activedata="' + activedata + '"]').first();
                            if (scrollTo != null && scrollTo != undefined) {								
								scrollTo.addClass('itemselected');
                                scrollTo = scrollTo.closest('li.js-administration-dropdowntree-group');
                                $(container).animate({
                                    scrollTop: scrollTo.offset().top - container.offset().top + container.scrollTop()
                                });
                            }
                        }, 1);
                    }
                });

                $editConfigurationAddNewValueSelectA.off('click').on('click', function (event) {
                    event.preventDefault();

                    var $this = $(this);
					$('#strDropDown .dropdown-menu a').removeClass('itemselected');					
                    var type = $this.attr('type');
                    var siteguid = $this.attr('siteguid');
                    var webguid = $this.attr('webguid');
                    var listguid = $this.attr('listguid');
                    function generateValueTypeLabel($whichLink) {
                        var currentText = $whichLink.text();

                        if (currentText === '') {
                            return '' + currentText + '';
                        }
                        else {
                            return generateValueTypeLabel($whichLink.closest('ul').siblings('a').not('.dropdown-toggle')) + '' + currentText + '';
                        }
                    }

                    var typeName = generateValueTypeLabel($this);
                    var addNewValueSelected = ($this.attr('activedata'));
                    $editConfigurationAddNewValueSelect.data('activedata', addNewValueSelected);

                    $this.closest('.dropdown')
                         .children('.dropdown-toggle')
                         .children('.js-administration-dropdowntree-select-display')
                         .text(typeName)
						 .attr('type', type)
						 .attr('siteguid', siteguid)
						 .attr('webguid', webguid)
						 .attr('listguid', listguid)
                         .data('selected-value-type', {
                             type: typeName
                         });
                });
                GetAllKeys();
            }, CallBackFunctionFailure, null);
        }

        function GetAllKeys() {
            $('#table-KeysData > tbody tr').remove();
            var $element = $('.js-administration-dropdowntree-select-display');
            ws_ajaxCall('/keyconfiguration/GetKeys', { server: $('#select-webapp').val(),
                type: $element.attr('type'),
                siteguid: $element.attr('siteguid'),
                webguid: $element.attr('webguid'),
                listguid: $element.attr('listguid'),
                havingvalues: $("#keyvaluestatusdropdown").val(),
                pagenumber: pagenumber,
                pagesize: $("#dropdownpagesize").val(),
                namefilter: $.trim($('#txtNameFilter').val()),
                orderby: orderby,
                ordersort: orderSort
            }, CallBackSuccess, CallBackFunctionFailure, null);

        }

        function CallBackSuccess(data) {
            var pageCount = null;
            var keyCount = null;
            var keys = null;
            var message = '';
            if (data.PageCount != undefined && data.PageCount != null) {
                pageCount = data.PageCount;                
            }

            if (data.KeyCount != undefined && data.KeyCount != null) {
                keyCount = data.KeyCount;
            }

            if (data.Keys != undefined && data.Keys != null) {
                keys = data.Keys;
                var xmlDocument = $(loadXMLString(keys));
                var keys = xmlDocument.find("Keys").find("Key");
                if (keys != undefined && keys != null && keys.length > 0) {
                    $.each(keys, function (k, v) {
                        var row = CreateRow($(v));
                        $("#table-KeysData > tbody:last").append(row);
                    });
                }

                var theCount = data.PageCount;
                if (theCount > 0) {
                    enablePaging(data.PageCount, 7);
                    var recordcount = $('#dropdownpagesize').val() * (pagenumber);
                    if (data.KeyCount >= recordcount) {
                        var therecords = ($('#dropdownpagesize').val() * (-1 + pagenumber)) + 1;
                        message = 'Displaying ' + therecords + ' to ' + (therecords + parseInt($('#dropdownpagesize').val()) - 1) + ' of ' + data.KeyCount;
                    }
                    else {
                        var therecords = ($('#dropdownpagesize').val() * (-1 + pagenumber)) + 1;
                        message = 'Displaying ' + therecords + ' to ' + (data.KeyCount) + ' of ' + data.KeyCount;
                    }
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "success", true);
                }
            }            
            
            $('#rowDisplay').text(message);
            ws_hideProgressBar();
            if (_globalMessage != null && _globalMessage != undefined && $.trim(_globalMessage).length != 0) {
                   wsLib_createBootstrapAlert($('#js-notice-message'), _globalMessage, "success", true);
               }
        }

        function CreateRow(node) {
            var markup = null;
            if (node != null) {
                var Name = node.attr("Name");
                var Type = node.attr("Type");
                var Description = node.attr("Description");
                var childNodes = node.find("KeyAssignment");
                var $element = $('.js-administration-dropdowntree-select-display');
                var secondColumnValue = '';
                var $type = $element.attr('type');
                if ($type.toLowerCase() == 'all') {                    
                    var AssignedTo = '';
                    if (childNodes != null && childNodes != undefined && childNodes.length > 0) {
                        for (var i = 0; i < childNodes.length; i++) {
                            AssignedTo += $(childNodes[i]).attr("AssignedTo") + ", ";
                        }
                    }

                    AssignedTo = $.trim(AssignedTo).replace(/(^,)|(,$)/g, "");
                    AssignedTo = $.trim(AssignedTo).replace(/(,)/g, ",<br />");
                    secondColumnValue = AssignedTo;
                }
                else {                    
                    if (childNodes.length > 0) {
                        secondColumnValue = $(childNodes[0]).attr("Value");
                    }
                    else {
                        secondColumnValue = '';
                    }
                }

                var url = encodeURI("/KeyConfiguration/EditKey?k=" + Name + "&server=" + $('#select-webapp').val());
                markup = '<tr>' +
                                        '<td><a href="' + url + '">' + Name + '</a> <a href="' + url + '" class="edit"><i class="icon-edit"></i></a></td>' +
                                        '<td>' + secondColumnValue + '</td>' +
                                        '<td>' + Type + '</td>' +
                                        '<td>' + Description + '</td>' +
                                 '</tr> ';
            }

            return markup;
        }

        function CallBackFunctionFailure(xhr, status, error, callbackdata) {
            ws_hideProgressBar();
            if (xhr.statusText != null && xhr.statusText != undefined) {
                wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
            }
        }

        var itemactivedata = 0;
        function MakeStructure(xml) {
            var html = '<div class="dropdown">';
            $.each(xml.find('options').children('option'), function (k, v) {
                var node = $(v);
                if (node.attr("Name").toString().toLowerCase() == 'all') {
                    var count = (node.attr("Count") == "") ? "(0)" : "(" + node.attr("Count") + ")";
                    html +=
                                                            '<a class="dropdown-toggle" data-toggle="dropdown" href="#">' +
                                                            '<span class="dropdown-toggle-symbol"></span>' +
                                                            '<span class="js-administration-dropdowntree-select-display" type="all" listguid="" webguid="" siteguid="">All Sites and Lists' + count + '</span>' +                                                            
                                                            '</a>' +
                                                            '<ul class="dropdown-menu">';
                    html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a class="js-addnewvalue-toggle-view-master-0" data-corresponding-value-type="-1"  activedata="' + (itemactivedata++) + '" href="#" type="All" siteguid="" webguid="" listguid=""><span>All Sites and Lists' + count + '</span></a>' +
                                    '</li>';
                }
                else if (node.attr("Name").toString().toLowerCase() == 'global') {
                    var count = (node.attr("Count") == "") ? "" : "(" + node.attr("Count") + ")";
                    html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + (itemactivedata++) + '" href="#" type="Global" siteguid="" webguid="" listguid=""><span>Global' + count + '</span></a>' +
                                    '</li>   ';
                }
                else if (node.attr("Type").toString().toLowerCase() == 'site') {
                    var name = node.attr("Name");
                    var siteguid = node.attr("SiteGUID");
                    var webguid = node.attr("WebGUID");
                    var listguid = node.attr("ListGUID");
                    var type = node.attr("Type");
                    var count = (node.attr("Count") == "") ? "" : "(" + node.attr("Count") + ")";
                    html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a type="Site" siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '" class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + (itemactivedata++) + '" href="#"><span><b>' + name + count + '/</b></span></a>';
                    var childnodes = node.children('option');
                    if (childnodes != null && childnodes != undefined && childnodes.length > 0) {
                        html += '<ul>';
                        html += TraverseChildren(childnodes);
                        html += '</ul>';
                    }

                    html += '</li>';
                }
            });

            html += '</ul></div>';
            if (dropdownMarkup == undefined) {
                dropdownMarkup = html;
            }

            return html;
        }

        function TraverseChildren(children) {
            var html = '';
            if (children.length > 0) {
                for (var i = 0; i < children.length; i++) {
                    var node = $(children[i]);
                    var name = node.attr("Name");
                    var siteguid = node.attr("SiteGUID");
                    var webguid = node.attr("WebGUID");
                    var listguid = node.attr("ListGUID");
                    var type = node.attr("Type");
                    var count = (node.attr("Count") == "") ? "" : "(" + node.attr("Count") + ")";
                    if (type.toLowerCase() == "site") {
                        html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a type="Site"  siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '" class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + (itemactivedata++) + '" +  href="#"><span><b>' + name + count + '/</b></span></a>';
                    }
                    else {
                        html += '<li class="js-administration-dropdowntree-group">';
                        html += '<a type="List"  siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '" class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + (itemactivedata++) + '" href="#"><span>' + name + count + '</span></a>';
                    }

                    if (type.toLowerCase() == "site") {
                        var childnodes = node.children('option');
                        if (childnodes != null && childnodes != undefined && childnodes.length > 0) {
                            html += '<ul>';
                            html += TraverseChildren(childnodes);
                            html += '</ul>';
                        }
                    }

                    html += '</li>';
                }
            }

            return html;
        }
    </script>
    <script>
        // Hoa's code
        var numberOfValueTypes = 1; // ### ATTENTION - This number should be the amount of types of Values that exist in this form.
        wsLib_toggleViews("createwith", 2, "radio", "no", 200);
        wsLib_toggleViews("rowadd", 2, "default");
        wsLib_toggleViews("addnewvalue", (numberOfValueTypes + 1), "default", "no");
        (function () {            
            var $editConfigurationValue = $('#js-administration-editconfiguration-value');
            var $editConfigurationAddNewValueSelect = $('#strDropDown');
            $editConfigurationValue.off('click.editToggle')
                                              .off('click.editSave')
                                              .off('click.deleteRow')
                                              .off('click.addRow')
                                              .on('click.editToggle', '.js-administration-editconfiguration-value-edittoggle', function (event) {
                                                  event.preventDefault();

                                                  var $currentParameterItem = $(this).closest('.js-administration-editconfiguration-value-item');

                                                  $currentParameterItem.children('td').find('.js-administration-editconfiguration-value-edittoggle').closest('div').toggle();

                                                  $currentParameterItem.find('.js-administration-editconfiguration-value-display').toggle();
                                                  $currentParameterItem.find('.js-administration-editconfiguration-value-form').toggle();
                                              }).on('click.editSave', '.js-administration-editconfiguration-value-editsave', function (event) {
                                                  event.preventDefault();

                                                  $(this).closest('tr').find('.js-administration-editconfiguration-value-form').find('input, select').each(function () {
                                                      var $currentInput = $(this);
                                                      var $currentDisplay = $currentInput.closest('.js-administration-editconfiguration-value-form').siblings('.js-administration-editconfiguration-value-display');

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          $currentDisplay.text(wsPlugin_capitaliseFirstLetter($currentInput.prop('checked') + ""));
                                                      }
                                                      else if ($currentInput.attr('type') === 'radio') {
                                                          $currentDisplay.text(wsPlugin_capitaliseFirstLetter(!$currentInput.prop('checked') + ""));
                                                      }
                                                      else if ($currentInput.is('select')) {
                                                          $currentDisplay.text($currentInput.val());
                                                      }
                                                      else {
                                                          $currentDisplay.text($currentInput.val());
                                                      }
                                                  });
                                              }).on('click.deleteRow', '.js-administration-editconfiguration-value-deleterow', function (event) {
                                                  event.preventDefault();

                                                  $(this).closest('tr').remove();
                                              }).on('click.addRow', '.js-administration-editconfiguration-value-addrow', function (event) {
                                                  event.preventDefault();

                                                  var selectedValueTypeLabel = $editConfigurationAddNewValueSelect.children('.dropdown')
                                                                                    .children('.dropdown-toggle')
                                                                                    .children('.js-administration-dropdowntree-select-display')
                                                                                    .data('selected-value-type');

                                                  var currentRowHTML = '';
                                                  var currentRowData = [];

                                                  $(this).closest('tr.row-add')
                           .children('td')
                           .children('div.js-form-active')
                           .find('input, select').each(function (index) {
                               var $currentInput = $(this);

                               if ($currentInput.attr('type') === 'checkbox') {
                                   currentRowData.push({
                                       index: index,
                                       data: $currentInput.prop('checked'),
                                       dataDisplay: wsPlugin_capitaliseFirstLetter($currentInput.prop('checked') + ""),
                                       type: "checkbox",
                                       HTML: $currentInput
                                   });

                                   $currentInput.prop('checked', false);
                               }
                               else if ($currentInput.attr('type') === 'radio') {
                                   currentRowData.push({
                                       index: index,
                                       data: $currentInput.prop('checked'),
                                       dataDisplay: wsPlugin_capitaliseFirstLetter($currentInput.prop('checked') + ""),
                                       type: "radio",
                                       HTML: $currentInput
                                   });

                                   $currentInput.prop('checked', true);
                               }
                               else if ($currentInput.is('select')) {
                                   $currentInput.find(':selected').attr('selected', 'selected');

                                   currentRowData.push({
                                       index: index,
                                       data: $currentInput.val(),
                                       dataDisplay: $currentInput.val(),
                                       type: "select",
                                       HTML: $currentInput.clone()
                                   });

                                   $currentInput.find(':selected').removeAttr('selected');
                               }
                               else {
                                   currentRowData.push({
                                       index: index,
                                       data: $currentInput.val(),
                                       dataDisplay: $currentInput.val(),
                                       type: "text",
                                       HTML: $currentInput
                                   });

                                   $currentInput.val('');
                               }
                           });

                                                  var currentPlugData = {
                                                      scope: selectedValueTypeLabel.type,
                                                      value: currentRowData[0].data,
                                                      valueDisplay: currentRowData[0].dataDisplay,
                                                      type: currentRowData[0].type,
                                                      HTML: currentRowData[0].HTML
                                                  };



                                                  currentRowHTML += '<tr class="js-administration-editconfiguration-value-item">';
                                                  currentRowHTML += '<td>';
                                                  currentRowHTML += '<div class="js-administration-editconfiguration-value-display contain-long-word">' + currentPlugData.scope + '</div>';
                                                  currentRowHTML += '<div class="js-administration-editconfiguration-value-form contain-long-word js-initial-hide" style="display: none;">';

                                                  currentRowHTML += currentPlugData.scope;

                                                  currentRowHTML += '</div>';
                                                  currentRowHTML += '</td>';
                                                  currentRowHTML += '<td>';
                                                  currentRowHTML += '<div class="pull-right">';
                                                  currentRowHTML += '<div>';
                                                  currentRowHTML += '<a class="js-administration-editconfiguration-value-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                                                  currentRowHTML += '<a class="js-administration-editconfiguration-value-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                                                  currentRowHTML += '</div>';
                                                  currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                                                  currentRowHTML += '<button class="js-administration-editconfiguration-value-editsave js-administration-editconfiguration-value-edittoggle btn btn-primary"><span>Save</span></button>';
                                                  currentRowHTML += '<button class="js-administration-editconfiguration-value-edittoggle btn"><span>Cancel</span></button>';
                                                  currentRowHTML += '</div>';
                                                  currentRowHTML += '</div>';
                                                  currentRowHTML += '<div class="js-administration-editconfiguration-value-display">' + currentPlugData.valueDisplay + '</div>';
                                                  currentRowHTML += '<div class="js-administration-editconfiguration-value-form js-initial-hide" style="display: none;">';

                                                  if (currentPlugData.type === 'checkbox') {
                                                      currentRowHTML += '<ul class="checkbox-group">';
                                                      currentRowHTML += '<li>';
                                                      currentRowHTML += '<label>';
                                                      currentRowHTML += '<input type="checkbox"' + (currentPlugData.value ? 'checked="checked"' : '') + '>';
                                                      currentRowHTML += '</label>';
                                                      currentRowHTML += '</li>';
                                                      currentRowHTML += '</ul>';
                                                  }
                                                  else if (currentPlugData.type === 'radio') {
                                                      var valueItemLength = $editConfigurationValue.find('.js-administration-editconfiguration-value-item').length;

                                                      currentRowHTML += '<ul class="checkbox-group inline-list">';
                                                      currentRowHTML += '<li>';
                                                      currentRowHTML += '<label>';
                                                      currentRowHTML += '<input type="radio" name="boolean_item_' + valueItemLength + '"' + (currentPlugData.value ? ' checked="checked"' : ' ') + '>';
                                                      currentRowHTML += '<span>True</span>';
                                                      currentRowHTML += '</label>';
                                                      currentRowHTML += '</li>';
                                                      currentRowHTML += '<li>';
                                                      currentRowHTML += '<label>';
                                                      currentRowHTML += '<input type="radio" name="boolean_item_' + valueItemLength + '"' + (currentPlugData.value ? ' ' : ' checked="checked"') + '>';
                                                      currentRowHTML += '<span>False</span>';
                                                      currentRowHTML += '</label>';
                                                      currentRowHTML += '</li>';
                                                      currentRowHTML += '</ul>';
                                                  }
                                                  else if (currentPlugData.type === 'select') {
                                                      currentRowHTML += '<select class="input-mid">';
                                                      currentRowHTML += currentPlugData.HTML.html();
                                                      currentRowHTML += '</select>';
                                                  }
                                                  else {
                                                      currentRowHTML += '<input type="text" class="input-mid" value="' + currentPlugData.value + '">';
                                                  }

                                                  currentRowHTML += '</div>';
                                                  currentRowHTML += '</td>';
                                                  currentRowHTML += '</tr>';

                                                  $editConfigurationValue.find('.row-add').first().before(currentRowHTML);
                                              });

                                          })();

                                          (function () {
                                              $('.js-dropdowntree-target').each(function () {
                                                  var $currentDropdownTreeSelectTarget = $(this);

                                                  $currentDropdownTreeSelectTarget.find('.js-menu-inactive').on('click.preventInactiveEvents', function (event) {
                                                      event.stopImmediatePropagation();
                                                      event.preventDefault();
                                                  });

                                                  $currentDropdownTreeSelectTarget.on('click.chooseNewItem', '.dropdown-menu a', function (event) {
                                                      event.preventDefault();
                                                      var $this = $(this);
                                                      function generateValueTypeLabel($whichLink) {
                                                          var currentText = $whichLink.text();
                                                          if (currentText === '') {
                                                              return '' + currentText + '';
                                                          }
                                                          else {
                                                              return generateValueTypeLabel($whichLink.closest('ul').siblings('a').not('.dropdown-toggle')) + '' + currentText + '';
                                                          }
                                                      }

                                                      var typeName = generateValueTypeLabel($this);



                                                      $this.closest('.dropdown')
                                                        .children('.dropdown-toggle')
                                                        .children('.js-administration-dropdowntree-select-display')
                                                        .text(typeName)
                                                        .data('selected-value-type', {
                                                            type: typeName
                                                        });

                                                      var addNewValueSelected = parseInt($this.attr('activedata'));

                                                      $currentDropdownTreeSelectTarget.data('activedata', addNewValueSelected);
                                                  });
                                              });
                                          })();
    </script>
    <script>
        function clearPaging() {
            $('#div-paging').html('');
            $('#div-paging').html('<ul id="pagination-elmt"class="pagination-sm"></ul>');
        }

        function enablePaging(totalPages, visiblePages) {
            $('#pagination-elmt').twbsPagination({
                totalPages: totalPages,
                visiblePages: visiblePages,
                onPageClick: function (event, page) {
                    _globalMessage = '';
                    pagenumber = page;                    
                    GetAllKeys();
                }
            });
        }

        function resetSortingFunctionality() {
            var ths = $('#table-KeysData').find('th[sort-indicator]').removeClass().attr('sort-indicator', 'NoSort');
            orderby = "Name";
            orderSort = "DESC";
        }

        function ApplySorting() {
            var ths = $('#table-KeysData').find('tr.table-sort').find('th').unbind('sort').off('click');
            $('#table-KeysData').find('tr.table-sort').applySorting(function (event, data) {
                ws_showProgressBar();
                _globalMessage = '';
                orderby = data.SortKey;
                orderSort = (data.SortOrder.toLowerCase() == 'descending' ? 'DESC' : 'ASC');                
                GetAllKeys();               
                return false;
            });
        }
    </script>
</asp:Content>
