﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Log File Viewer
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Log File Viewer</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/Logging">Logging</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="pull-right">
                                <button class="btn pull-right" id="btn-download-all"><span>Download All Logs</span></button>
                            </li>
                            <li class="active">
                                <h1>Log File Viewer</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div id="div-all-message" style="display:none;">
					Note: Please use 'Download All Logs' or 'Download Log Set' feature to verify all the logs.
				</div>
                <div>
                    <span id="js-notice-message"></span>
                </div>
                <div class="row-fluid">
                    <table class="table table-header">
                        <tbody>
                            <tr>
                                <td>
                                    <form id="logviewer-form">
                                        <div>
                                            <label>Log</label>
                                            <select name="component" class="input-medium">
                                                <option selected="selected" value="sharevis.log">Core</option>
                                                <option value="sharevis_svservice.log">SVService</option>
                                                <option value="sharevis_timer.log">Timer</option>
                                                <option value="sharevis_ca.log">Central Admin</option>
                                                <option value="sharevis_svadm.log">Svadm</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Type</label>
                                            <select name="filter" class="input-medium">
                                                <option selected="selected" value="None">None</option>
                                                <option value="|Debug,|Info,|Warn,|Error">Debug</option>
                                                <option value="|Info,|Warn,|Error">Info</option>
                                                <option value="|Warn,|Error">Warn</option>
                                                <option value="|Error">Error</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Context</label>
                                            <select id="" name="context" class="input-medium">
                                                <option selected="selected" value="0">0 Lines</option>
                                                <option value="10">10 Lines</option>
                                                <option value="25">25 Lines</option>
                                                <option value="50">50 Lines</option>
                                                <option value="100">100 Lines</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Display</label>
                                            <select name="logSize" class="input-medium" id="select-logSize">
                                                <option selected="selected" value="500000">Last 500KB</option>
                                                <option value="1000000">Last 1MB</option>
                                                <option value="0">All</option>
                                            </select>
                                        </div>
                                        <div class='form-actions'>
                                            <label>&nbsp;</label>
                                                <button class="btn" id="btn-display-logset" type="button" name="">
                                                <span>
                                                Display Log Set
                                                </span>
                                                </button>
                                                <button class="btn" id="btn-download-logset" type="button" name="">
                                                <span>
                                                Download Log Set
                                                </span>
                                                </button>
                                        </div>
                                    </form>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <ul id="log-list" class="log-list" style=" word-wrap: break-word;" ></ul>
                </div>
                <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_admincommands.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            var _globalMessage = '<%=TempData["Logging_Message"] %>';
            $(document).ready(function () {
                ws_showProgressBar();

                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {
                    if (_globalMessage != '') {
                        wsLib_createBootstrapAlert($('#js-notice-message'), _globalMessage, "success", true);
                    }

                    ws_hideProgressBar();
                    $("#btn-display-logset").click(function () {
                        ws_showProgressBar();
                        var serializeData = $("#logviewer-form").serialize();
                        ws_ajaxCall('/logviewer/GetLogs', serializeData, function (data, callbackdata) {

                            var logList = $("#log-list");
                            logList.html('');

                            if (data != '') {
                                logList.html(data);
                            }
                            else {
                                logList.html('<%= Resources.Resource.WFAdminWeb_Page_LogViewer_NoLogsFound %>');
                            }

                            ws_hideProgressBar();
                        }, function (xhr, status, error) {

                            wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_UnknownError %>', "error", true);
                            ws_hideProgressBar();

                        }, null);
                    });

                    $("#select-webapp").change(function () {
                        SetupLinks();
                    });

                    $("#select-logSize").change(function () {
                        var selectedValue = $(this).val();
                        if (selectedValue == 0) {
                            $('#div-all-message').show(300);
                            $("#btn-display-logset").hide(300);
                        }
                        else {
                            $('#div-all-message').hide(300);
                            $("#btn-display-logset").show(300);
                        }
                        return false;
                    });

                    $("#btn-download-logset").click(function () {
                        var serializeData = $("#logviewer-form").serialize();
                        window.open("/logviewer/DownloadCurrentLogs?" + serializeData);
                        return false;
                    });

                    $("#btn-download-all").click(function () {
                        window.open("/logviewer/Downloadall");
                        return false;
                    });
                });
            });
        </script>
</asp:Content>